/*
 * ȣХϥե
 *	Ͻ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_calc.c,v 1.2 2000/08/25 11:52:42 tonton Exp $
 */

#include <sys/param.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

/* ѥ᡼ */
#define		WAAC_PRM_FILENAME			"acalz.dat"
#define		WAAC_PRM_OS					"os"
#define		WAAC_PRM_BRWS				"browser"
#define		WAAC_PRM_IGNORE				"ignoreindex"

/* ȣԣ̥ͣե */
#define		WAAC_HTML_GIFNAME			"bar.gif"
#define		WAAC_HTML_MAXVALUE			500
#define		WAAC_HTML_GIFHIGHT			12
#define		WAAC_PRN_MENU_SSTR(anc)		"\t\t<td><a href=\"#" anc "\">"
#define		WAAC_PRN_MENU_ESTR			"</a></td>"
#define		WAAC_PRN_PUT_SSDIV(anc) \
				"<div>\n\t<br>\n\t<hr>\n\t<a name=\"" anc "\"><strong>"
#define		WAAC_PRN_PUT_ESDIV			"</strong></a><br>"

/* Ͼ */
typedef struct {
	gint			seq_no;				// ֹ
	gint			access_num;			// 
	gchar			*find_str;			// ʸ
	gchar			*disp_str;			// ɽʸ
} WAAC_ANA_DATA;
typedef struct {
	gint			ana_cnt;			// ܿ
	WAAC_ANA_DATA	*ana_data;			// ϥǡ
} WAAC_ANA_INFO;

/* ̵뤹ʸ */
typedef struct {
	gchar			*ignore_str;		// ̵뤹ʸ
} WAAC_IGN_DATA;
typedef struct {
	gint			ign_cnt;			// ܿ
	WAAC_IGN_DATA	*ign_data;			// ̵뤹ʸǡ
} WAAC_IGN_INFO;

static gint			Waac_total_access;		// 
static gint			Waac_month_access[12];	// ̥
static gint			Waac_week_access[54];	// ̥
static gint			Waac_dweek_access[7];	// ̥
static gint			Waac_date_access[31];	// ̥
static gint			Waac_time_access[25];	// ̥
static WAAC_ANA_INFO	Waac_os_access;		// ϣ̥
static WAAC_ANA_INFO	Waac_brws_access;	// ֥饦̥
static WAAC_ANA_INFO	Waac_host_access;	// ۥ̥̾
static WAAC_ANA_INFO	Waac_ref_access;	// ̥
static WAAC_ANA_INFO	Waac_page_access;	// ڡ̥
static WAAC_IGN_INFO	Waac_ignore_info;	// ̵뤹ʸ

/* ץȥ */
static gboolean		waac_read_logfile(gchar *, FILE *);
static void			waac_free_ana_info(WAAC_ANA_INFO *, gboolean);
static gboolean		waac_check_date(gchar *);
static void			waac_check_osbrws(gchar *);
static void			waac_check_ref(gchar *);
static void			waac_modify_chr_code(gchar *);
static void			waac_delete_index(gchar *);
static void			waac_ignore_string(gchar *, gchar);
static void			waac_ignore_port_no(gchar *);
static void			waac_check_hostip(gchar *);
static void			waac_join_access(WAAC_ANA_INFO *);
static gint			waac_sort_seq_no(const void *, const void *);
static gint			waac_sort_access_num(const void *, const void *);
static void			waac_write_csv_file(FILE *);
static void			waac_write_csv_ana_data(FILE *,
								gchar *, gint, WAAC_ANA_DATA *);
static void			waac_write_html_file(FILE *);
static void			waac_write_html_ana_data(FILE *,
								gint, WAAC_ANA_DATA *);
static void			waac_write_html_gif_file(gchar *);
static void			waac_write_txt_file(FILE *);
static void			waac_write_txt_ana_data(FILE *,
								gchar *, gint, WAAC_ANA_DATA *);

/*===============
 *   ̾ : waa_get_total_access()
 *     ǽ : μ
 *    : 
 */
gint				waa_get_total_access(void)
{
	return Waac_total_access;
}

/*===============
 *   ̾ : waa_get_access_num()
 *     ǽ : μ
 *    : 
 */
gint				waa_get_access_num(
gint				window_no,			// (I) ֹ
gint				item_no				// (I) ֹ
)
{
	gint			item_num = 0;		// ̥

	if (window_no == WAA_WINNO_MONTH) {
		item_num = Waac_month_access[item_no];
	}
	else if (window_no == WAA_WINNO_WEEK) {
		item_num = Waac_week_access[item_no];
	}
	else if (window_no == WAA_WINNO_DWEEK) {
		item_num = Waac_dweek_access[item_no];
	}
	else if (window_no == WAA_WINNO_DATE) {
		item_num = Waac_date_access[item_no];
	}
	else if (window_no == WAA_WINNO_TIME) {
		item_num = Waac_time_access[item_no];
	}
	else if (window_no == WAA_WINNO_OS) {
		item_num = Waac_os_access.ana_data[item_no].access_num;
	}
	else if (window_no == WAA_WINNO_BRWS) {
		item_num = Waac_brws_access.ana_data[item_no].access_num;
	}
	else if (window_no == WAA_WINNO_HOST) {
		item_num = Waac_host_access.ana_data[item_no].access_num;
	}
	else if (window_no == WAA_WINNO_REF) {
		item_num = Waac_ref_access.ana_data[item_no].access_num;
	}
	else if (window_no == WAA_WINNO_PAGE) {
		item_num = Waac_page_access.ana_data[item_no].access_num;
	}

	return item_num;
}

/*===============
 *   ̾ : waa_get_item_num()
 *     ǽ : ɽܿμ
 *    : ɽܿ
 */
gint				waa_get_item_num(
gint				window_no			// (I) ֹ
)
{
	gint			item_num = 0;		// ɽܿ

	if (window_no == WAA_WINNO_OS) {
		item_num = Waac_os_access.ana_cnt;
	}
	else if (window_no == WAA_WINNO_BRWS) {
		item_num = Waac_brws_access.ana_cnt;
	}
	else if (window_no == WAA_WINNO_HOST) {
		item_num = Waac_host_access.ana_cnt;
	}
	else if (window_no == WAA_WINNO_REF) {
		item_num = Waac_ref_access.ana_cnt;
	}
	else if (window_no == WAA_WINNO_PAGE) {
		item_num = Waac_page_access.ana_cnt;
	}

	return item_num;
}

/*===============
 *   ̾ : waa_get_disp_string()
 *     ǽ : ɽʸμ
 *    : ɽʸ
 */
gchar				*waa_get_disp_string(
gint				window_no,			// (I) ֹ
gint				item_no				// (I) ֹ
)
{
	gchar			*disp_item;			// ɽʸ

	if (window_no == WAA_WINNO_OS) {
		disp_item = Waac_os_access.ana_data[item_no].disp_str;
	}
	else if (window_no == WAA_WINNO_BRWS) {
		disp_item = Waac_brws_access.ana_data[item_no].disp_str;
	}
	else if (window_no == WAA_WINNO_HOST) {
		disp_item = Waac_host_access.ana_data[item_no].disp_str;
	}
	else if (window_no == WAA_WINNO_REF) {
		disp_item = Waac_ref_access.ana_data[item_no].disp_str;
	}
	else if (window_no == WAA_WINNO_PAGE) {
		disp_item = Waac_page_access.ana_data[item_no].disp_str;
	}

	return disp_item;
}

/*===============
 *   ̾ : waa_read_analyze_info()
 *     ǽ : Ͼեɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gboolean			waa_read_analyze_info(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			item_len;			// Ĺ
	gint			os_cnt;				// ϣӹܿ
	gint			brws_cnt;			// ֥饦ܿ
	gint			ign_cnt;			// ̵뤹ʸܿ
	gchar			fname[MAXPATHLEN];	// ե̾
	gchar			key_str[100];		// 
	gchar			key_value[100];		// 
	gchar			*value_ptr;			//
	FILE			*infp;				// եݥ

	memset(&Waac_os_access, 0, sizeof(WAAC_ANA_INFO));
	memset(&Waac_brws_access, 0, sizeof(WAAC_ANA_INFO));
	memset(&Waac_ignore_info, 0, sizeof(WAAC_IGN_INFO));

	strcpy(fname, WAAC_PRM_FILENAME);
	infp = fopen(fname, "r");
	if (infp) {
		os_cnt = 0;
		brws_cnt = 0;
		ign_cnt = 0;
		while (wmc_get_key_value(key_str, key_value, infp) == TRUE) {
			if (!strcmp(key_str, WAAC_PRM_OS)) {
				value_ptr = strchr(key_value, ',') + 1;
				if (value_ptr) {
					Waac_os_access.ana_data =
						g_realloc(Waac_os_access.ana_data,
						sizeof(WAAC_ANA_DATA) * (os_cnt + 1));
					Waac_os_access.ana_data[os_cnt].seq_no = os_cnt + 1;
					Waac_os_access.ana_data[os_cnt].access_num = 0;
					item_len = strlen(value_ptr);
					Waac_os_access.ana_data[os_cnt].disp_str =
						g_malloc0((item_len + 1) * sizeof(char));
					memcpy(Waac_os_access.ana_data[os_cnt].disp_str,
								value_ptr, item_len * sizeof(char));
					item_len = strlen(key_value) - item_len - 1;
					Waac_os_access.ana_data[os_cnt].find_str =
						g_malloc0((item_len + 1) * sizeof(char));
					memcpy(Waac_os_access.ana_data[os_cnt].find_str,
								key_value, item_len * sizeof(char));
					os_cnt++;
				}
			}
			else if (!strcmp(key_str, WAAC_PRM_BRWS)) {
				value_ptr = strchr(key_value, ',') + 1;
				if (value_ptr) {
					Waac_brws_access.ana_data =
						g_realloc(Waac_brws_access.ana_data,
						sizeof(WAAC_ANA_DATA) * (brws_cnt + 1));
					Waac_brws_access.ana_data[brws_cnt].seq_no =
														brws_cnt + 1;
					Waac_brws_access.ana_data[brws_cnt].access_num = 0;
					item_len = strlen(value_ptr);
					Waac_brws_access.ana_data[brws_cnt].disp_str =
						g_malloc0((item_len + 1) * sizeof(char));
					memcpy(Waac_brws_access.ana_data[brws_cnt].disp_str,
								value_ptr, item_len * sizeof(char));
					item_len = strlen(key_value) - item_len - 1;
					Waac_brws_access.ana_data[brws_cnt].find_str =
						g_malloc0((item_len + 1) * sizeof(char));
					memcpy(Waac_brws_access.ana_data[brws_cnt].find_str,
								key_value, item_len * sizeof(char));
					brws_cnt++;
				}
			}
			else if (!strcmp(key_str, WAAC_PRM_IGNORE)) {
				Waac_ignore_info.ign_data =
					g_realloc(Waac_ignore_info.ign_data,
					sizeof(WAAC_IGN_DATA) * (ign_cnt + 1));
				Waac_ignore_info.ign_data[ign_cnt].ignore_str =
					g_malloc0((strlen(key_value) + 1) * sizeof(char));
				strcpy(Waac_ignore_info.ign_data[ign_cnt].ignore_str,
															key_value);
				ign_cnt++;
			}
		}
		Waac_os_access.ana_cnt = os_cnt;
		Waac_brws_access.ana_cnt = brws_cnt;
		Waac_ignore_info.ign_cnt = ign_cnt;
		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : waa_access_analyze()
 *     ǽ : 
 *    : TRUE= ｪλ, FALSE= ۾ｪλ
 */
gboolean			waa_access_analyze(
gboolean			init_flag			// (I) ե饰
										//		(TRUE= )
)
{
	gboolean		ret_code = TRUE;	// 
	gboolean		ana_flag;			// оݥե饰
	gint			ana_line;			// ιԿ
	gint			check_line;			// åԿ
	gchar			fname[MAXPATHLEN];	// ե̾
	gchar			read_line[1000];	// ɤ߹߹
	FILE			*anafp;				// եݥ

	ana_flag = FALSE;
	ana_line = 0;
	check_line = (gint)waa_get_param(WAA_PRM_KEY_CHECKLINE, 0);

	if (init_flag == TRUE) {
		waa_init_analyze();
	}
	else {
		qsort(Waac_os_access.ana_data, Waac_os_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_seq_no);
		qsort(Waac_brws_access.ana_data, Waac_brws_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_seq_no);
	}

	strcpy(fname, waa_get_param(WAA_PRM_KEY_LOGFILE, 0));
	anafp = fopen(fname, "r");
	if (anafp) {
		read_line[0] = '\0';
		while (waac_read_logfile(read_line, anafp)) {
			ana_line++;
			if ((ana_line % check_line) == 0) {
				waa_pbar_value_change((gfloat)ana_line);
			}

			if (!strncmp(read_line, "1#", 2)) {
				ana_flag = waac_check_date(read_line);
			}
			else if (ana_flag == TRUE) {
				if (!strncmp(read_line, "2#", 2)) {
					waac_check_osbrws(read_line);
				}
				else if (!strncmp(read_line, "3#", 2)) {
					waac_check_ref(read_line);
				}
				else if (!strncmp(read_line, "4#", 2)) {
					waac_check_hostip(read_line);
				}
			}
		}
		fclose(anafp);

		waac_join_access(&Waac_os_access);
		waac_join_access(&Waac_brws_access);

		qsort(Waac_os_access.ana_data, Waac_os_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_access_num);
		qsort(Waac_brws_access.ana_data, Waac_brws_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_access_num);
		qsort(Waac_host_access.ana_data, Waac_host_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_access_num);
		qsort(Waac_ref_access.ana_data, Waac_ref_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_access_num);
		qsort(Waac_page_access.ana_data, Waac_page_access.ana_cnt,
					sizeof(WAAC_ANA_DATA), waac_sort_access_num);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : waa_get_analyze_line()
 *     ǽ : ιԿ
 *    : ιԿ
 */
gint				waa_get_analyze_line(void)
{
	gint			ana_line;			// ιԿ
	gchar			*fname;				// ե̾
	gchar			read_line[1000];	// ɤ߹߹
	FILE			*anafp;				// եݥ

	ana_line = 0;

	fname = waa_get_param(WAA_PRM_KEY_LOGFILE, 0);
	anafp = fopen(fname, "r");
	if (anafp) {
		read_line[0] = '\0';
		while (waac_read_logfile(read_line, anafp)) {
			ana_line++;
		}
		fclose(anafp);
	}
	else {
		perror(fname);
	}

	return ana_line;
}

/*===============
 *   ̾ : waa_write_access_file()
 *     ǽ : Ϸ̤ե˽
 *    : TRUE= ｪλ, FALSE= ϥ顼
 */
gint				waa_write_access_file(
gchar				*file_name			// (I) ϥե̾
)
{
	gboolean		ret_code = TRUE;	// 
	gchar			*err_msg;			// 顼å
	FILE			*outfp;				// եݥ

	outfp = fopen(file_name, "w");
	if (outfp) {
		if (strstr(file_name, ".csv")) {
			waac_write_csv_file(outfp);
		}
		else if (strstr(file_name, ".htm")) {
			waac_write_html_file(outfp);
			waac_write_html_gif_file(file_name);
		}
		else {
			waac_write_txt_file(outfp);
		}
		fclose(outfp);
	}
	else {
		err_msg = g_malloc0((strlen(file_name) +
					strlen(_(WAA_STR_ERR_WRITE)) + 2) * sizeof(char));
		sprintf(err_msg, "%s\n%s", _(WAA_STR_ERR_WRITE), file_name);
		wmc_create_emsg_dialog(NULL, _(WAA_STR_ERROR), err_msg);
		g_free(err_msg);

		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : waac_read_logfile()
 *     ǽ : եɤ߹
 *    : TRUE= ｪλ, FALSE= ۾ｪλ
 */
static gboolean		waac_read_logfile(
gchar				*read_line,			// ( O ) ɤ߹
FILE				*ana_fp				// (I/O) եݥ
)
{
static gchar		work_line[1000];	// ɤ߹ѥХåե
	gboolean		ret_code = TRUE;	// 
	gint			cpy_length;			// ԡʸĹ
	gchar			*work_ptr;			//
	gchar			*tab_ptr;			// ְ

	read_line[0] = '\0';
	if (work_line[0] == '\0') {
		if (feof(ana_fp)) {
			ret_code = FALSE;
		}
		else {
			while (fgets(work_line, sizeof(work_line), ana_fp)) {
				if (strchr(work_line, '#')) {
break;
				}
				work_line[0] = '\0';
			}
			if (work_line[0] == '\0') {
				ret_code = FALSE;
			}
			else {
				work_ptr = work_line + (strlen(work_line) - 1);
				while ((*work_ptr == '\n') || (*work_ptr == '\r')) {
					*(work_ptr--) = '\0';
				}
			}
		}
	}

	if (ret_code == TRUE) {
		work_ptr = work_line;
		tab_ptr = strchr(work_line, '\t');
		if (tab_ptr > 0) {
			cpy_length = tab_ptr - work_ptr;
			memcpy(read_line, work_line, cpy_length);
			read_line[cpy_length] = '\0';
			cpy_length = strlen(work_line) - (cpy_length + 1);
			memmove(work_line, tab_ptr + 1, cpy_length);
			work_line[cpy_length] = '\0';
		}
		else {
			strcpy(read_line, work_line);
			work_line[0] = '\0';
		}
	}

	return ret_code;
}

/*===============
 *   ̾ : waa_init_analyze()
 *     ǽ : Ͼν
 *    : ʤ
 */
void				waa_init_analyze(void)
{
	Waac_total_access = 0;
	memset(Waac_month_access, 0, sizeof(Waac_month_access));
	memset(Waac_week_access, 0, sizeof(Waac_week_access));
	memset(Waac_dweek_access, 0, sizeof(Waac_dweek_access));
	memset(Waac_date_access, 0, sizeof(Waac_date_access));
	memset(Waac_time_access, 0, sizeof(Waac_time_access));
	waac_free_ana_info(&Waac_os_access, FALSE);
	waac_free_ana_info(&Waac_brws_access, FALSE);
	waac_free_ana_info(&Waac_host_access, TRUE);
	waac_free_ana_info(&Waac_ref_access, TRUE);
	waac_free_ana_info(&Waac_page_access, TRUE);
}

/*===============
 *   ̾ : waac_free_ana_info()
 *     ǽ : Ͼν
 *    : ʤ
 */
static void			waac_free_ana_info(
WAAC_ANA_INFO		*ana_info,			// (I/O) Ͼ
gboolean			free_all			// ( I ) TRUE= 
)
{
	gint			loop_cnt;			// 롼ץ

	if (free_all == TRUE) {
		for (loop_cnt = 0; loop_cnt < ana_info->ana_cnt; loop_cnt++) {
			ana_info->ana_data[loop_cnt].access_num = 0;
			if (ana_info->ana_data[loop_cnt].disp_str) {
				free(ana_info->ana_data[loop_cnt].disp_str);
				ana_info->ana_data[loop_cnt].disp_str = NULL;
			}
		}

		ana_info->ana_cnt = 0;
		free(ana_info->ana_data);
		ana_info->ana_data = NULL;
	}
	else {
		qsort(ana_info->ana_data, ana_info->ana_cnt,
			sizeof(WAAC_ANA_DATA), waac_sort_seq_no);
		for (loop_cnt = 0; loop_cnt < ana_info->ana_cnt; loop_cnt++) {
			ana_info->ana_data[loop_cnt].access_num = 0;
		}
	}
}

/*===============
 *   ̾ : waac_check_date()
 *     ǽ : դΥå
 *    : TRUE= о, FALSE= о
 */
static gboolean		waac_check_date(
gchar				*check_line			// (I) å
)
{
	gboolean		ret_code = FALSE;	// 
	gboolean		find_flag;			// ե饰
	gboolean		spc_page;			// ϥڡե饰
	gint			loop_cnt;			// 롼ץ
	gint			page_len;			// ϥڡĹ
	gchar			check_page[50];		// ϥڡ
	gint			year_value;			// ǯ
	gint			month_value;		// 
	gint			day_value;			// 
	gint			hour_value;			// 
	gboolean		spc_date;			// ջե饰
	time_t			log_date;			// 
	struct tm		log_sdate;			// 
	time_t			start_date;			// ϳ
	time_t			end_date;			// Ͻλ
	time_t			nyear_date;			// ǯΣ
	struct tm		nyear_sdate;		// ǯΣ
	gint			week_year;			// ǯν
	gchar			*work_ptr;			// ѥݥ
	WAAC_ANA_DATA	*ana_ptr;			// Ͼ

	// ڡ̲
	memset(check_page, 0, sizeof(check_page));
	work_ptr = strchr(check_line, ')');
	page_len = work_ptr - check_line;
	work_ptr = strchr(check_line, '(') + 1;
	page_len -= (work_ptr - check_line);
	if (page_len > 0) {
		memcpy(check_page, work_ptr, page_len);
	}
	
	find_flag = FALSE;
	ana_ptr = Waac_page_access.ana_data;
	for (loop_cnt = 0; (find_flag == FALSE) &&
		(loop_cnt < Waac_page_access.ana_cnt); loop_cnt++) {
		if (!strcmp(check_page, ana_ptr->disp_str)) {
			ana_ptr->access_num++;
			find_flag = TRUE;
		}
		ana_ptr++;
	}

	if (find_flag == FALSE) {
		Waac_page_access.ana_cnt++;
		Waac_page_access.ana_data =
			g_realloc(Waac_page_access.ana_data,
			sizeof(WAAC_ANA_DATA) * Waac_page_access.ana_cnt);
		ana_ptr =
			&Waac_page_access.ana_data[Waac_page_access.ana_cnt - 1];

		ana_ptr->access_num = 1;
		ana_ptr->disp_str =
			g_malloc0((strlen(check_page) + 1) * sizeof(char));
		strcpy(ana_ptr->disp_str, check_page);
	}

	// աֲ
	sprintf(check_page, "1#(%s)",
		(gchar *)waa_get_param(WAA_PRM_KEY_PAGE, 0));
	spc_page = (gboolean)waa_get_param(WAA_PRM_KEY_SPCPAGE, 0);
	if ((spc_page == FALSE) || strstr(check_line, check_page)) {
		work_ptr = strchr(check_line, ')') + 1;
		year_value = atoi(work_ptr);
		work_ptr = strchr(work_ptr, '/') + 1;
		month_value = atoi(work_ptr) - 1;
		work_ptr = strchr(work_ptr, '/') + 1;
		day_value = atoi(work_ptr);
		work_ptr = strchr(work_ptr, ' ') + 1;
		hour_value = atoi(work_ptr);
		memset(&log_sdate, 0, sizeof(struct tm));
		log_sdate.tm_year = year_value - 1900;
		log_sdate.tm_mon = month_value;
		log_sdate.tm_mday = day_value;
		log_date = mktime(&log_sdate);
		memcpy(&log_sdate, localtime(&log_date), sizeof(struct tm));
		spc_date = (gboolean)waa_get_param(WAA_PRM_KEY_SPCDATE, 0);
		start_date = (time_t)waa_get_param(WAA_PRM_KEY_STARTDATE, 0);
		end_date = (time_t)waa_get_param(WAA_PRM_KEY_ENDDATE, 0);
		if ((spc_date == FALSE) ||
			((start_date <= log_date) && (log_date <= end_date))) {
			memset(&nyear_sdate, 0, sizeof(struct tm));
			nyear_sdate.tm_year = log_sdate.tm_year;
			nyear_sdate.tm_mon = 0;
			nyear_sdate.tm_mday = 1;
			nyear_date = mktime(&nyear_sdate);
			memcpy(&nyear_sdate,
				localtime(&nyear_date), sizeof(struct tm));
			week_year = (log_sdate.tm_yday + nyear_sdate.tm_wday) / 7;

			Waac_total_access++;
			Waac_month_access[month_value]++;
			Waac_week_access[week_year]++;
			Waac_dweek_access[log_sdate.tm_wday]++;
			Waac_date_access[day_value - 1]++;
			Waac_time_access[hour_value]++;
			ret_code = TRUE;
		}
	}

	return ret_code;
}

/*===============
 *   ̾ : waac_check_osbrws()
 *     ǽ : ϣӡ֥饦Υå
 *    : ʤ
 */
static void			waac_check_osbrws(
gchar				*check_line			// (I) å
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		find_flag;			// ե饰
	WAAC_ANA_DATA	*ana_ptr;			// Ͼ

	if (strcmp(check_line, "2#")) {
		// ϣ
		find_flag = FALSE;
		ana_ptr = Waac_os_access.ana_data;
		for (loop_cnt = 0; (find_flag == FALSE) &&
			(loop_cnt < Waac_os_access.ana_cnt); loop_cnt++) {
			if (strstr(check_line, ana_ptr->find_str)) {
				ana_ptr->access_num++;
				find_flag = TRUE;
			}
			ana_ptr++;
		}

		// ֥饦
		find_flag = FALSE;
		ana_ptr = Waac_brws_access.ana_data;
		for (loop_cnt = 0; (find_flag == FALSE) &&
			(loop_cnt < Waac_brws_access.ana_cnt); loop_cnt++) {
			if (strstr(check_line, ana_ptr->find_str)) {
				ana_ptr->access_num++;
				find_flag = TRUE;
			}
			ana_ptr++;
		}
	}
}

/*===============
 *   ̾ : waac_check_ref()
 *     ǽ : ̤Υå
 *    : ʤ
 */
static void			waac_check_ref(
gchar				*check_line			// (I) å
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		prm_value;			// ѥ᡼
	gboolean		find_flag;			// ե饰
	WAAC_ANA_DATA	*ana_ptr;			// Ͼ

	if (strlen(check_line) > 2) {
		check_line += 2;
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_CODECHANGE, 0);
		if (prm_value == TRUE) {
			waac_modify_chr_code(check_line);
		}
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_IGNOREINDEX, 0);
		if (prm_value == TRUE) {
			waac_delete_index(check_line);
		}
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_IGNOREQUESTION, 0);
		if (prm_value == TRUE) {
			waac_ignore_string(check_line, '?');
		}
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_IGNORESHARP, 0);
		if (prm_value == TRUE) {
			waac_ignore_string(check_line, '#');
		}
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_IGNOREPORTNO, 0);
		if (prm_value == TRUE) {
			waac_ignore_port_no(check_line);
		}
		prm_value = (gboolean)waa_get_param(WAA_PRM_KEY_SMALLIZE, 0);
		if (prm_value == TRUE) {
			wmc_lcase(check_line);
		}

		if (check_line[0] != '\0') {
			find_flag = FALSE;
			ana_ptr = Waac_ref_access.ana_data;
			for (loop_cnt = 0; (find_flag == FALSE) &&
				(loop_cnt < Waac_ref_access.ana_cnt); loop_cnt++) {
				if (strstr(check_line, ana_ptr->disp_str)) {
					ana_ptr->access_num++;
					find_flag = TRUE;
				}
				ana_ptr++;
			}

			if (find_flag == FALSE) {
				Waac_ref_access.ana_cnt++;
				Waac_ref_access.ana_data =
					g_realloc(Waac_ref_access.ana_data,
					sizeof(WAAC_ANA_DATA) * Waac_ref_access.ana_cnt);
				ana_ptr = &Waac_ref_access.ana_data[
							Waac_ref_access.ana_cnt - 1];

				ana_ptr->access_num = 1;
				ana_ptr->disp_str =
					g_malloc0((strlen(check_line) + 1) * sizeof(char));
				strcpy(ana_ptr->disp_str, check_line);
			}
		}
	}
}

/*===============
 *   ̾ : waac_modify_chr_code()
 *     ǽ : ʸɤѴ
 *    : ʤ
 */
static void			waac_modify_chr_code(
gchar				*check_string		// (I/O) Ѵ
)
{
	gchar			*cur_ptr;			// å
	gint			copy_len;			// ԡĹ
	gchar			*modify_string;		// Ѵʸ
	gchar			*modify_ptr;		// Ѵʸ
	gchar			chr_code[4];		// ʸ

	cur_ptr = strchr(check_string, '%');
	if (cur_ptr != NULL) {
		modify_string = g_malloc0((strlen(check_string) + 1) *
												sizeof(char));
		modify_ptr = modify_string;

		while (*cur_ptr) {
			copy_len = cur_ptr - check_string;
			memcpy(modify_ptr, check_string, copy_len);
			modify_ptr += copy_len;
			check_string += (copy_len + 3/*%??*/);
			sprintf(chr_code, "%2.2s", cur_ptr + 1);
			*(modify_ptr++) = strtol(chr_code, NULL, 16);
			cur_ptr = strchr(cur_ptr, '%');
			if (cur_ptr != NULL) {
				strcpy(modify_ptr, check_string);
			}
		}

		strcpy(check_string, modify_string);
		free(modify_string);
	}
}

/*===============
 *   ̾ : waac_delete_index()
 *     ǽ : ̵뤹ʸκ
 *    : ʤ
 */
static void			waac_delete_index(
gchar				*check_string		// (I/O) Ѵ
)
{
	gint			loop_cnt;			// 롼ץ
	gint			true_len;			// ͭʸ
	gchar			*ign_pos;			// ̵뤹ʸ
	WAAC_IGN_DATA	*ign_ptr;			// ̵뤹ʸ

	ign_ptr = Waac_ignore_info.ign_data;
	for (loop_cnt = 0;
		loop_cnt < Waac_ignore_info.ign_cnt; loop_cnt++) {
		ign_pos = strstr(check_string, ign_ptr->ignore_str);
		if (ign_pos) {
			true_len = ign_pos - check_string;
			check_string[true_len] = '\0';
		}
		ign_ptr++;
	}
}

/*===============
 *   ̾ : waac_ignore_string()
 *     ǽ : ʸʹߤ
 *    : ʤ
 */
static void			waac_ignore_string(
gchar				*check_string,		// (I/O) Ѵ
gchar				spc_string			// ( I ) ʸ
)
{
	gint			true_len;			// ͭʸ
	gchar			*ign_pos;			// ̵뤹ʸ

	ign_pos = strchr(check_string, spc_string);
	if (ign_pos) {
		true_len = ign_pos - check_string;
		check_string[true_len] = '\0';
	}
}

/*===============
 *   ̾ : waac_ignore_port_no()
 *     ǽ : ݡֹ
 *    : ʤ
 */
static void			waac_ignore_port_no(
gchar				*check_string		// (I/O) Ѵ
)
{
	gint			true_len;			// ͭʸ
	gchar			*pno_pos;			// ݡֹ
	gchar			*slash_pos;			// å

	pno_pos = strchr(check_string, ':');
	if (pno_pos) {
		while (pno_pos) {
			slash_pos = strchr(pno_pos, '/');
			if ((slash_pos - pno_pos) > 1) {
				true_len = strlen(slash_pos);
				memmove(pno_pos, slash_pos, true_len);
				*(pno_pos + true_len) = '\0';
			}
			pno_pos = strchr((pno_pos + 1), ':');
		}
	}
}

/*===============
 *   ̾ : waac_check_hostip()
 *     ǽ : ۥ̾ɣХɥ쥹Υå
 *    : ʤ
 */
static void			waac_check_hostip(
gchar				*check_line			// (I) å
)
{
	gint			loop_cnt;			// 롼ץ
	gint			period_num = 0;		// ԥꥪɿ
	gint			f_bit;				// ƬΣӥåȿ
	gint			s_bit;				// Σӥåȿ
	gint			t_bit;				// μΣӥåȿ
	gchar			*cur_pos;			// ߤβϰ
	gchar			*fin_pos = NULL;	// ǽԥꥪɰ
	gchar			host_name[100];		// ۥ̾
	gboolean		ign_ip;				// ɣХɥ쥹̵뤹
	gboolean		find_flag;			// ե饰
	WAAC_ANA_DATA	*ana_ptr;			// Ͼ

	memset(host_name, 0, sizeof(host_name));
	// ۥ̾
	if (check_line[2] != '(') {
		cur_pos = strchr(check_line + 3, '(');
		memcpy(host_name, check_line + 2, (cur_pos - check_line) - 2);
		cur_pos = strchr(host_name, '.');
		if (cur_pos) {
			cur_pos++;
		}
		fin_pos = cur_pos;
		while (cur_pos) {
			period_num++;
			cur_pos = strchr(cur_pos, '.');
			if (cur_pos) {
				cur_pos++;
				fin_pos = cur_pos;
			}
		}
	}

	if ((fin_pos == NULL) && (host_name[0] != '\0')) {
		// 餯ۥ
		sprintf(check_line, "%s", host_name);
	}
	else if ((fin_pos != NULL) && (atoi(fin_pos) == 0)) {
		// ۥ̾
		if (period_num >= 4) {
			period_num -= 2;
		}
		else {
			period_num = 1;
		}
		cur_pos = host_name;
		for (loop_cnt = 0; loop_cnt < period_num; loop_cnt++) {
			cur_pos = strchr(cur_pos, '.') + 1;
		}
		sprintf(check_line, "*.%s", cur_pos);
	}
	else {
		// ۥ̾ԡʣɣХɥ쥹Τߡ
		ign_ip = (gboolean)waa_get_param(WAA_PRM_KEY_IGNOREIP, 0);
		if (ign_ip == FALSE) {
			cur_pos = strchr(check_line, '(') + 1;
			strcpy(host_name, cur_pos);
			host_name[strlen(host_name) - 1] = '\0';
			ign_ip = (gboolean)waa_get_param(WAA_PRM_KEY_SPCCLASS, 0);
			if (ign_ip == FALSE) {
				strcpy(check_line, host_name);
			}
			else {
				f_bit = atoi(host_name);
				cur_pos = strchr(host_name, '.') + 1;
				s_bit = atoi(cur_pos);
				cur_pos = strchr(cur_pos, '.') + 1;
				t_bit = atoi(cur_pos);
				if (f_bit < 127) {
					sprintf(check_line, "%d.*.*.*", f_bit);
				}
				else if (f_bit < 192) {
					sprintf(check_line, "%d.%d.*.*", f_bit, s_bit);
				}
				else if (f_bit < 224) {
					sprintf(check_line, "%d.%d.%d.*",
									f_bit, s_bit, t_bit);
				}
				else {
					strcpy(check_line, host_name);
				}
			}
		}
		else {
			check_line[0] = '\0';
		}
	}

	if (check_line[0] != '\0') {
		find_flag = FALSE;
		ana_ptr = Waac_host_access.ana_data;
		for (loop_cnt = 0; (find_flag == FALSE) &&
			(loop_cnt < Waac_host_access.ana_cnt); loop_cnt++) {
			if (!strcmp(check_line, ana_ptr->disp_str)) {
				ana_ptr->access_num++;
				find_flag = TRUE;
			}
			ana_ptr++;
		}

		if (find_flag == FALSE) {
			Waac_host_access.ana_cnt++;
			Waac_host_access.ana_data =
				g_realloc(Waac_host_access.ana_data,
				sizeof(WAAC_ANA_DATA) * Waac_host_access.ana_cnt);
			ana_ptr = &Waac_host_access.ana_data[
						Waac_host_access.ana_cnt - 1];

			ana_ptr->access_num = 1;
			ana_ptr->disp_str =
				g_malloc0((strlen(check_line) + 1) * sizeof(char));
			strcpy(ana_ptr->disp_str, check_line);
		}
	}
}

/*===============
 *   ̾ : waac_join_access()
 *     ǽ : ϥǡη
 *    : ʤ
 */
static void			waac_join_access(
WAAC_ANA_INFO		*ana_info			// (I/O) Ͼ
)
{
	gint			main_cnt;			// 롼ץ
	gint			sub_cnt;			// 롼ץ
	WAAC_ANA_DATA	*main_ptr;			// Ͼ
	WAAC_ANA_DATA	*sub_ptr;			// Ͼ

	main_ptr = ana_info->ana_data;
	for (main_cnt = 0; main_cnt < (ana_info->ana_cnt - 1); main_cnt++) {
		if (main_ptr->access_num > 0) {
			sub_ptr = &ana_info->ana_data[main_cnt + 1];
			for (sub_cnt = main_cnt + 1;
				sub_cnt < ana_info->ana_cnt; sub_cnt++) {
				if (!strcmp(main_ptr->disp_str, sub_ptr->disp_str)) {
					main_ptr->access_num += sub_ptr->access_num;
					sub_ptr->access_num = 0;
				}
				sub_ptr++;
			}
		} 
		main_ptr++;
	}
}

/*===============
 *   ̾ : waac_sort_seq_no()
 *     ǽ : ֹ祽
 *    : strcmp() Ʊ
 */
static gint			waac_sort_seq_no(
const void			*fst_ptr,			// (I) Ⱦ
const void			*snd_ptr			// (I) Ⱦ
)
{
	WAAC_ANA_DATA	*fst_data;			// Ͼ
	WAAC_ANA_DATA	*snd_data;			// Ͼ

	fst_data = (WAAC_ANA_DATA *)fst_ptr;
	snd_data = (WAAC_ANA_DATA *)snd_ptr;
	return (fst_data->seq_no - snd_data->seq_no);
}

/*===============
 *   ̾ : waac_sort_access_num()
 *     ǽ : 祽
 *    : strcmp() Ʊ
 */
static gint			waac_sort_access_num(
const void			*fst_ptr,			// (I) Ⱦ
const void			*snd_ptr			// (I) Ⱦ
)
{
	WAAC_ANA_DATA	*fst_data;			// Ͼ
	WAAC_ANA_DATA	*snd_data;			// Ͼ

	fst_data = (WAAC_ANA_DATA *)fst_ptr;
	snd_data = (WAAC_ANA_DATA *)snd_ptr;
	return (fst_data->access_num - snd_data->access_num);
}

/*===============
 *   ̾ : waac_write_csv_file()
 *     ǽ : Ϸ̤ե˽ϡʣãӣַ
 *    : ʤ
 */
static void			waac_write_csv_file(
FILE				*outfp				// (I/O) եݥ
)
{
	gboolean		spc_value;			// ֡뷿ѥХåե
	time_t			start_date;			// ϳ
	gchar			start_str[20];		// ϳ
	time_t			end_date;			// Ͻλ
	gchar			end_str[20];		// Ͻλ
	gchar			*str_value;			// ʸѥХåե
	gint			loop_cnt;			// 롼ץ
	gchar			*date_str[7];		// ʸ

	date_str[0] = g_strconcat(_(WAA_PRN_DWEEK_SUN), NULL);
	date_str[1] = g_strconcat(_(WAA_PRN_DWEEK_MON), NULL);
	date_str[2] = g_strconcat(_(WAA_PRN_DWEEK_TUE), NULL);
	date_str[3] = g_strconcat(_(WAA_PRN_DWEEK_WED), NULL);
	date_str[4] = g_strconcat(_(WAA_PRN_DWEEK_THU), NULL);
	date_str[5] = g_strconcat(_(WAA_PRN_DWEEK_FRI), NULL);
	date_str[6] = g_strconcat(_(WAA_PRN_DWEEK_SAT), NULL);

	// 
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCDATE, 0);
	fprintf(outfp, "\"%s\",", _(WAA_PRN_ANADATE));
	if (spc_value == FALSE) {
		fprintf(outfp, "\"%s\"\n", _(WAA_PRN_NOSPC));
	}
	else {
		start_date = (time_t)waa_get_param(WAA_PRM_KEY_STARTDATE, 0);
		strftime(start_str, sizeof(start_str),
			"%Y/%m/%d", localtime(&start_date));
		end_date = (time_t)waa_get_param(WAA_PRM_KEY_ENDDATE, 0);
		strftime(end_str, sizeof(end_str),
			"%Y/%m/%d", localtime(&end_date));
		fprintf(outfp, "\"%s  %s\"\n", start_str, end_str);
	}

	// Ͼ
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCPAGE, 0);
	str_value = waa_get_param(WAA_PRM_KEY_PAGE, 0);
	fprintf(outfp, "\"%s\",", _(WAA_PRN_ANAPAGE));
	if (spc_value == FALSE) {
		fprintf(outfp, "\"%s\"\n", _(WAA_PRN_NOSPC));
	}
	else {
		fprintf(outfp, "\"%s\"\n", str_value);
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\",%d\n", _(WAA_PRN_TOTAL), Waac_total_access);
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\"\n", _(WAA_PRN_TMONTH));
	for (loop_cnt = 0; loop_cnt < 12; loop_cnt++) {
		if (Waac_month_access[loop_cnt] > 0) {
			fprintf(outfp, "\"%d%s\",%d\n", loop_cnt + 1,
				_(WAA_PRN_MONTH), Waac_month_access[loop_cnt]);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\"\n", _(WAA_PRN_TWEEK));
	for (loop_cnt = 0; loop_cnt < 54; loop_cnt++) {
		if (Waac_week_access[loop_cnt] > 0) {
			fprintf(outfp, "\"%d%s\",%d\n", loop_cnt + 1,
				_(WAA_PRN_WEEK), Waac_week_access[loop_cnt]);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\"\n", _(WAA_PRN_TDWEEK));
	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		if (Waac_dweek_access[loop_cnt] > 0) {
			fprintf(outfp, "\"%s\",%d\n",
				date_str[loop_cnt], Waac_dweek_access[loop_cnt]);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\"\n", _(WAA_PRN_TDATE));
	for (loop_cnt = 0; loop_cnt < 31; loop_cnt++) {
		if (Waac_date_access[loop_cnt] > 0) {
			fprintf(outfp, "\"%d%s\",%d\n", loop_cnt + 1,
				_(WAA_PRN_DATE), Waac_date_access[loop_cnt]);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "\"%s\"\n", _(WAA_PRN_TTIME));
	for (loop_cnt = 0; loop_cnt < 25; loop_cnt++) {
		if (Waac_time_access[loop_cnt] > 0) {
			fprintf(outfp, "\"%d%s\",%d\n", loop_cnt,
				_(WAA_PRN_TIME), Waac_time_access[loop_cnt]);
		}
	}

	// ϣ
	waac_write_csv_ana_data(outfp, _(WAA_PRN_TOS),
		Waac_os_access.ana_cnt, Waac_os_access.ana_data);

	// ֥饦
	waac_write_csv_ana_data(outfp, _(WAA_PRN_TBRWS),
		Waac_brws_access.ana_cnt, Waac_brws_access.ana_data);

	// ۥ̾
	waac_write_csv_ana_data(outfp, _(WAA_PRN_THOST),
		Waac_host_access.ana_cnt, Waac_host_access.ana_data);

	// 
	waac_write_csv_ana_data(outfp, _(WAA_PRN_TREF),
		Waac_ref_access.ana_cnt, Waac_ref_access.ana_data);

	// ڡ
	waac_write_csv_ana_data(outfp, _(WAA_PRN_TPAGE),
		Waac_page_access.ana_cnt, Waac_page_access.ana_data);

	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		g_free(date_str[loop_cnt]);
	}
}

/*===============
 *   ̾ : waac_write_csv_ana_data()
 *     ǽ : Ͼǡե˽ϡʣãӣַ
 *    : ʤ
 */
static void			waac_write_csv_ana_data(
FILE				*outfp,				// (I/O) եݥ
gchar				*title,				// ( I ) ȥ̾
gint				ana_cnt,			// ( I ) ܿ
WAAC_ANA_DATA		*ana_ptr 			// ( I ) Ͼ
)
{
	gint			loop_cnt;			// 롼ץ
	gint			access_num;			// 

	fprintf(outfp, "\n");
	access_num = 0;
	for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
		if (ana_ptr->access_num > 0) {
			access_num++;
		}
		ana_ptr++;
	}

	fprintf(outfp, "\"%s\",%d\n", title, access_num);
	for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
		ana_ptr--;
		if (ana_ptr->access_num > 0) {
			fprintf(outfp, "\"%s\",%d\n",
				ana_ptr->disp_str, ana_ptr->access_num);
		}
	}
}

/*===============
 *   ̾ : waac_write_html_file()
 *     ǽ : Ϸ̤ե˽ϡʣȣԣ̷ͣ
 *    : ʤ
 */
static void			waac_write_html_file(
FILE				*outfp				// (I/O) եݥ
)
{
	gboolean		spc_value;			// ֡뷿ѥХåե
	time_t			now_date;			// 
	gchar			now_str[20];		// 
	time_t			start_date;			// ϳ
	gchar			start_str[20];		// ϳ
	time_t			end_date;			// Ͻλ
	gchar			end_str[20];		// Ͻλ
	gchar			*str_value;			// ʸѥХåե
	gint			loop_cnt;			// 롼ץ
	gdouble			max_value;			// 
	gchar			*date_str[7];		// ʸ

	date_str[0] = g_strconcat(_(WAA_PRN_DWEEK_SUN), NULL);
	date_str[1] = g_strconcat(_(WAA_PRN_DWEEK_MON), NULL);
	date_str[2] = g_strconcat(_(WAA_PRN_DWEEK_TUE), NULL);
	date_str[3] = g_strconcat(_(WAA_PRN_DWEEK_WED), NULL);
	date_str[4] = g_strconcat(_(WAA_PRN_DWEEK_THU), NULL);
	date_str[5] = g_strconcat(_(WAA_PRN_DWEEK_FRI), NULL);
	date_str[6] = g_strconcat(_(WAA_PRN_DWEEK_SAT), NULL);

	now_date = time(NULL);
	strftime(now_str, sizeof(now_str),
		"%Y-%m-%d %H:%M:%S", localtime(&now_date));
	fprintf(outfp,
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">\n");
	fprintf(outfp, "<html lang=\"ja\">\n");
	fprintf(outfp, "<head>\n");
	fprintf(outfp, "\t<meta http-equiv=\"Content-Type\""
				" content=\"text/html; charset=EUC-JP\">\n");
	fprintf(outfp,
		"\t<meta name=\"date\" content=\"%s\">\n", now_str);
	fprintf(outfp, "\t<title>%s</title>\n", _(WAA_PRN_HEADER));
	fprintf(outfp, "</head>\n");

	fprintf(outfp, "<body>\n");
	fprintf(outfp, "<div>\n");
	fprintf(outfp, "\t<strong>%s</strong>\n", _(WAA_PRN_HTMLTITLE));
	fprintf(outfp, "\t<br><br>\n");

	// 
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCDATE, 0);
	fprintf(outfp, "\t%s: ", _(WAA_PRN_ANADATE));
	if (spc_value == FALSE) {
		fprintf(outfp, "%s", _(WAA_PRN_NOSPC));
	}
	else {
		start_date = (time_t)waa_get_param(WAA_PRM_KEY_STARTDATE, 0);
		strftime(start_str, sizeof(start_str),
			"%Y/%m/%d", localtime(&start_date));
		end_date = (time_t)waa_get_param(WAA_PRM_KEY_ENDDATE, 0);
		strftime(end_str, sizeof(end_str),
			"%Y/%m/%d", localtime(&end_date));
		fprintf(outfp, "%s  %s", start_str, end_str);
	}
	fprintf(outfp, "\t<br>\n");

	// Ͼ
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCPAGE, 0);
	str_value = waa_get_param(WAA_PRM_KEY_PAGE, 0);
	fprintf(outfp, "\t%s: ", _(WAA_PRN_ANAPAGE));
	if (spc_value == FALSE) {
		fprintf(outfp, "%s", _(WAA_PRN_NOSPC));
	}
	else {
		fprintf(outfp, "%s", str_value);
	}
	fprintf(outfp, "\t<br>\n");

	// 
	fprintf(outfp, "\t%s: %d<br>\n",
		_(WAA_PRN_TOTAL), Waac_total_access);
	fprintf(outfp, "</div>\n");

	// ˥塼
	fprintf(outfp, "\n<div>\n");
	fprintf(outfp, "\t<br>\n");
	fprintf(outfp, "\t<table summary=\"Menu\">\n");
	fprintf(outfp, "\t<tr>\n");
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("month"),
					_(WAA_PRN_TMONTH), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("week"),
					_(WAA_PRN_TWEEK), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("dweek"),
					_(WAA_PRN_TDWEEK), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("date"),
					_(WAA_PRN_TDATE), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("time"),
					_(WAA_PRN_TTIME), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "\t</tr>\n");
	fprintf(outfp, "\t<tr>\n");
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("os"),
					_(WAA_PRN_TOS), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("brws"),
					_(WAA_PRN_TBRWS), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("host"),
					_(WAA_PRN_THOST), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("ref"),
					_(WAA_PRN_TREF), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_MENU_SSTR("page"),
					_(WAA_PRN_TPAGE), WAAC_PRN_MENU_ESTR);
	fprintf(outfp, "\t</tr>\n");
	fprintf(outfp, "\t</table>\n");
	fprintf(outfp, "</div>\n");

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("month"),
					_(WAA_PRN_TMONTH), WAAC_PRN_PUT_ESDIV);
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < 12; loop_cnt++) {
		if (max_value < Waac_month_access[loop_cnt]) {
			max_value = Waac_month_access[loop_cnt];
		}
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < 12; loop_cnt++) {
			if (Waac_month_access[loop_cnt] > 0) {
				fprintf(outfp, "\t%2d%s(%d)<br>", loop_cnt + 1,
					_(WAA_PRN_MONTH), Waac_month_access[loop_cnt]);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(Waac_month_access[loop_cnt] * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("week"),
					_(WAA_PRN_TWEEK), WAAC_PRN_PUT_ESDIV);
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < 54; loop_cnt++) {
		if (max_value < Waac_week_access[loop_cnt]) {
			max_value = Waac_week_access[loop_cnt];
		}
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < 54; loop_cnt++) {
			if (Waac_week_access[loop_cnt] > 0) {
				fprintf(outfp, "\t%2d%s(%d)<br>", loop_cnt + 1,
					_(WAA_PRN_WEEK), Waac_week_access[loop_cnt]);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(Waac_week_access[loop_cnt] * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("dweek"),
					_(WAA_PRN_TDWEEK), WAAC_PRN_PUT_ESDIV);
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		if (max_value < Waac_dweek_access[loop_cnt]) {
			max_value = Waac_dweek_access[loop_cnt];
		}
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
			if (Waac_dweek_access[loop_cnt] > 0) {
				fprintf(outfp, "\t%s(%d)<br>",
					date_str[loop_cnt],
					Waac_dweek_access[loop_cnt]);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(Waac_dweek_access[loop_cnt] * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("date"),
					_(WAA_PRN_TDATE), WAAC_PRN_PUT_ESDIV);
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < 31; loop_cnt++) {
		if (max_value < Waac_date_access[loop_cnt]) {
			max_value = Waac_date_access[loop_cnt];
		}
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < 31; loop_cnt++) {
			if (Waac_date_access[loop_cnt] > 0) {
				fprintf(outfp, "\t%2d%s(%d)<br>", loop_cnt + 1,
					_(WAA_PRN_DATE), Waac_date_access[loop_cnt]);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(Waac_date_access[loop_cnt] * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("time"),
					_(WAA_PRN_TTIME), WAAC_PRN_PUT_ESDIV);
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < 25; loop_cnt++) {
		if (max_value < Waac_time_access[loop_cnt]) {
			max_value = Waac_time_access[loop_cnt];
		}
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < 25; loop_cnt++) {
			if (Waac_time_access[loop_cnt] > 0) {
				fprintf(outfp, "\t%2d%s(%d)<br>", loop_cnt + 1,
					_(WAA_PRN_TIME), Waac_time_access[loop_cnt]);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(Waac_time_access[loop_cnt] * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");

	// ϣ
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("os"),
					_(WAA_PRN_TOS), WAAC_PRN_PUT_ESDIV);
	waac_write_html_ana_data(outfp,
		Waac_os_access.ana_cnt, Waac_os_access.ana_data);

	// ֥饦
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("brws"),
					_(WAA_PRN_TBRWS), WAAC_PRN_PUT_ESDIV);
	waac_write_html_ana_data(outfp,
		Waac_brws_access.ana_cnt, Waac_brws_access.ana_data);

	// ۥ̾
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("host"),
					_(WAA_PRN_THOST), WAAC_PRN_PUT_ESDIV);
	waac_write_html_ana_data(outfp,
		Waac_host_access.ana_cnt, Waac_host_access.ana_data);

	// 
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("ref"),
					_(WAA_PRN_TREF), WAAC_PRN_PUT_ESDIV);
	waac_write_html_ana_data(outfp,
		Waac_ref_access.ana_cnt, Waac_ref_access.ana_data);

	// ڡ
	fprintf(outfp, "%s%s%s\n", WAAC_PRN_PUT_SSDIV("page"),
					_(WAA_PRN_TPAGE), WAAC_PRN_PUT_ESDIV);
	waac_write_html_ana_data(outfp,
		Waac_page_access.ana_cnt, Waac_page_access.ana_data);

	fprintf(outfp, "\n</body>\n");
	fprintf(outfp, "</html>\n");

	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		g_free(date_str[loop_cnt]);
	}
}

/*===============
 *   ̾ : waac_write_html_ana_data()
 *     ǽ : Ͼǡե˽ϡʣȣԣ̷ͣ
 *    : ʤ
 */
static void			waac_write_html_ana_data(
FILE				*outfp,				// (I/O) եݥ
gint				ana_cnt,			// ( I ) ܿ
WAAC_ANA_DATA		*ana_ptr 			// ( I ) Ͼ
)
{
	gint			loop_cnt;			// 롼ץ
	gdouble			max_value;			// 
	WAAC_ANA_DATA	*before_ptr;		// Ͼ

	before_ptr = ana_ptr;
	max_value = 0.0;
	for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
		if (max_value < ana_ptr->access_num) {
			max_value = ana_ptr->access_num;
		}
		ana_ptr++;
	}
	if (max_value > 0.0) {
		max_value = WAAC_HTML_MAXVALUE / max_value;
		for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
			ana_ptr--;
			if (ana_ptr->access_num > 0) {
				fprintf(outfp, "\t%s(%d)<br>",
					ana_ptr->disp_str, ana_ptr->access_num);
				fprintf(outfp, "<img src=\"%s\""
					" width=\"%d\" height=\"%d\" alt=\"Bar\"><br>\n",
					WAAC_HTML_GIFNAME,
					(gint)(ana_ptr->access_num * max_value),
					WAAC_HTML_GIFHIGHT);
			}
		}
	}
	fprintf(outfp, "</div>\n");
}

/*===============
 *   ̾ : waac_write_html_gif_file()
 *     ǽ : եν
 *    : ʤ
 */
static void			waac_write_html_gif_file(
gchar				*out_file			// (I) ե̾
)
{
	guchar			gif_image[] = {		// ᡼
						0x47, 0x49, 0x46, 0x38, 0x39, 0x61, 0x01, 0x00,
						0x0c, 0x00, 0xb3, 0xff, 0x00, 0xff, 0xff, 0xff,
						0xf6, 0xf6, 0xff, 0xeb, 0xec, 0xff, 0xdd, 0xde,
						0xff, 0xce, 0xd0, 0xff, 0xbf, 0xc2, 0xff, 0xb1,
						0xb4, 0xff, 0xa4, 0xa7, 0xff, 0x95, 0x98, 0xff,
						0x86, 0x89, 0xff, 0x78, 0x7d, 0xff, 0x6c, 0x71,
						0xff, 0x64, 0x69, 0xff, 0x00, 0x00, 0x00, 0xc0,
						0xc0, 0xc0, 0x00, 0x00, 0x00, 0x21, 0xf9, 0x04,
						0x01, 0x00, 0x00, 0x0e, 0x00, 0x2c, 0x00, 0x00,
						0x00, 0x00, 0x01, 0x00, 0x0c, 0x00, 0x40, 0x04,
						0x09, 0x90, 0x11, 0xa4, 0x8c, 0x58, 0xe9, 0x94,
						0x11, 0x22, 0x00, 0x3b
					};
	gchar			*dir_name;			// ǥ쥯ȥ̾
	gchar			*dir_pos;			// ǥ쥯ȥ
	gchar			file_name[200];		// ե̾
	gchar			*err_msg;			// 顼å
	FILE			*outfp;				// եݥ

	dir_name = strdup(out_file);
	dir_pos = strrchr(dir_name, '/');
	if (dir_pos != NULL) {
		*dir_pos = '\0';
	}
	sprintf(file_name, "%s/%s", dir_name, WAAC_HTML_GIFNAME);
	if (access(file_name, R_OK) < 0) {
		outfp = fopen(file_name, "wb");
		if (outfp) {
			fwrite(gif_image, sizeof(char), sizeof(gif_image), outfp);
			fclose(outfp);
		}
		else {
			err_msg = g_malloc0((strlen(file_name) +
						strlen(_(WAA_STR_ERR_WRITE)) + 2) *
						sizeof(char));
			sprintf(err_msg, "%s\n%s", _(WAA_STR_ERR_WRITE), file_name);
			wmc_create_emsg_dialog(NULL, _(WAA_STR_ERROR), err_msg);
			g_free(err_msg);
		}
	}

	free(dir_name);
}

/*===============
 *   ̾ : waac_write_txt_file()
 *     ǽ : Ϸ̤ե˽ϡʥƥȷ
 *    : ʤ
 */
static void			waac_write_txt_file(
FILE				*outfp				// (I/O) եݥ
)
{
	gboolean		spc_value;			// ֡뷿ѥХåե
	time_t			start_date;			// ϳ
	gchar			start_str[20];		// ϳ
	time_t			end_date;			// Ͻλ
	gchar			end_str[20];		// Ͻλ
	gchar			*str_value;			// ʸѥХåե
	gchar			put_fmt[20];		// ϥեޥå
	gchar			put_str[20];		// ʸ
	gint			loop_cnt;			// 롼ץ
	gchar			*date_str[7];		// ʸ

	date_str[0] = g_strconcat(_(WAA_PRN_DWEEK_SUN), NULL);
	date_str[1] = g_strconcat(_(WAA_PRN_DWEEK_MON), NULL);
	date_str[2] = g_strconcat(_(WAA_PRN_DWEEK_TUE), NULL);
	date_str[3] = g_strconcat(_(WAA_PRN_DWEEK_WED), NULL);
	date_str[4] = g_strconcat(_(WAA_PRN_DWEEK_THU), NULL);
	date_str[5] = g_strconcat(_(WAA_PRN_DWEEK_FRI), NULL);
	date_str[6] = g_strconcat(_(WAA_PRN_DWEEK_SAT), NULL);

	// 
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCDATE, 0);
	fprintf(outfp, "%s: ", _(WAA_PRN_ANADATE));
	if (spc_value == FALSE) {
		fprintf(outfp, "%s\n", _(WAA_PRN_NOSPC));
	}
	else {
		start_date = (time_t)waa_get_param(WAA_PRM_KEY_STARTDATE, 0);
		strftime(start_str, sizeof(start_str),
			"%Y/%m/%d", localtime(&start_date));
		end_date = (time_t)waa_get_param(WAA_PRM_KEY_ENDDATE, 0);
		strftime(end_str, sizeof(end_str),
			"%Y/%m/%d", localtime(&end_date));
		fprintf(outfp, "%s  %s\n", start_str, end_str);
	}

	// Ͼ
	spc_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCPAGE, 0);
	str_value = waa_get_param(WAA_PRM_KEY_PAGE, 0);
	fprintf(outfp, "%s: ", _(WAA_PRN_ANAPAGE));
	if (spc_value == FALSE) {
		fprintf(outfp, "%s\n", _(WAA_PRN_NOSPC));
	}
	else {
		fprintf(outfp, "%s\n", str_value);
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "%s: %d\n", _(WAA_PRN_TOTAL), Waac_total_access);
	fprintf(outfp, "\n");
	sprintf(put_str, "%d", Waac_total_access);
	sprintf(put_fmt, "%%%dd", strlen(put_str) + 1);

	// 
	fprintf(outfp, "%s\n", _(WAA_PRN_TMONTH));
	for (loop_cnt = 0; loop_cnt < 12; loop_cnt++) {
		if (Waac_month_access[loop_cnt] > 0) {
			sprintf(put_str, put_fmt, Waac_month_access[loop_cnt]);
			fprintf(outfp, "%2d%s:%s\n",
				loop_cnt + 1, _(WAA_PRN_MONTH), put_str);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "%s\n", _(WAA_PRN_TWEEK));
	for (loop_cnt = 0; loop_cnt < 54; loop_cnt++) {
		if (Waac_week_access[loop_cnt] > 0) {
			sprintf(put_str, put_fmt, Waac_week_access[loop_cnt]);
			fprintf(outfp, "%2d%s:%s\n",
				loop_cnt + 1, _(WAA_PRN_WEEK), put_str);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "%s\n", _(WAA_PRN_TDWEEK));
	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		if (Waac_dweek_access[loop_cnt] > 0) {
			sprintf(put_str, put_fmt, Waac_dweek_access[loop_cnt]);
			fprintf(outfp, "%s:%s\n",
				date_str[loop_cnt], put_str);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "%s\n", _(WAA_PRN_TDATE));
	for (loop_cnt = 0; loop_cnt < 31; loop_cnt++) {
		if (Waac_date_access[loop_cnt] > 0) {
			sprintf(put_str, put_fmt, Waac_date_access[loop_cnt]);
			fprintf(outfp, "%2d%s:%s\n",
				loop_cnt + 1, _(WAA_PRN_DATE), put_str);
		}
	}
	fprintf(outfp, "\n");

	// 
	fprintf(outfp, "%s\n", _(WAA_PRN_TTIME));
	for (loop_cnt = 0; loop_cnt < 25; loop_cnt++) {
		if (Waac_time_access[loop_cnt] > 0) {
			sprintf(put_str, put_fmt, Waac_time_access[loop_cnt]);
			fprintf(outfp, "%2d%s:%s\n",
				loop_cnt, _(WAA_PRN_TIME), put_str);
		}
	}

	// ϣ
	waac_write_txt_ana_data(outfp, _(WAA_PRN_TOS),
		Waac_os_access.ana_cnt, Waac_os_access.ana_data);

	// ֥饦
	waac_write_txt_ana_data(outfp, _(WAA_PRN_TBRWS),
		Waac_brws_access.ana_cnt, Waac_brws_access.ana_data);

	// ۥ̾
	waac_write_txt_ana_data(outfp, _(WAA_PRN_THOST),
		Waac_host_access.ana_cnt, Waac_host_access.ana_data);

	// 
	waac_write_txt_ana_data(outfp, _(WAA_PRN_TREF),
		Waac_ref_access.ana_cnt, Waac_ref_access.ana_data);

	// ڡ
	waac_write_txt_ana_data(outfp, _(WAA_PRN_TPAGE),
		Waac_page_access.ana_cnt, Waac_page_access.ana_data);

	for (loop_cnt = 0; loop_cnt < 7; loop_cnt++) {
		g_free(date_str[loop_cnt]);
	}
}

/*===============
 *   ̾ : waac_write_txt_ana_data()
 *     ǽ : Ͼǡե˽ϡʥƥȷ
 *    : ʤ
 */
static void			waac_write_txt_ana_data(
FILE				*outfp,				// (I/O) եݥ
gchar				*title,				// ( I ) ȥ̾
gint				ana_cnt,			// ( I ) ܿ
WAAC_ANA_DATA		*ana_ptr 			// ( I ) Ͼ
)
{
	gint			loop_cnt;			// 롼ץ
	gchar			put_fmt[20];		// ϥեޥå
	gchar			put_str[20];		// ʸ
	gint			access_num;			// 

	sprintf(put_str, "%d", Waac_total_access);
	sprintf(put_fmt, "%%%dd", strlen(put_str) + 1);

	fprintf(outfp, "\n");
	access_num = 0;
	for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
		if (ana_ptr->access_num > 0) {
			access_num++;
		}
		ana_ptr++;
	}

	fprintf(outfp, "%s (%d)\n", title, access_num);
	for (loop_cnt = 0; loop_cnt < ana_cnt; loop_cnt++) {
		ana_ptr--;
		sprintf(put_str, put_fmt, ana_ptr->access_num);
		if (ana_ptr->access_num > 0) {
			fprintf(outfp, "%s: %s\n", put_str, ana_ptr->disp_str);
		}
	}
}
