/*
 * ȣХϥե
 *	ե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_font.c,v 1.1 2000/08/25 11:52:42 tonton Exp $
 */

#include <gtk/gtk.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static gchar		*Waaf_fname;		// ե̾	

static GtkWidget	*waaf_create_font_window(GtkWidget *, gchar *);
static void			waaf_cb_destroy(void);
static void			waaf_cb_ok_clicked(GtkWidget *, gpointer, guint);

/*===============
 *   ̾ : waa_font_change()
 *     ǽ : ե򥦥ɥκ
 *    : ʤ
 */
gchar				*waa_font_change(
GtkWidget			*button,			// ( I ) ܥ
gchar				*font_name			// (I/O) ե̾
)
{
	GtkWidget		*parent_window;		// ƥɥ
	GtkWidget		*font_window;		// ե򥦥ɥ

	if (Waaf_fname) {
		g_free(Waaf_fname);
	}
	Waaf_fname = g_strconcat(font_name, NULL);
	parent_window = GTK_WIDGET(button)->parent;
	while (!GTK_IS_WINDOW(parent_window)) {
		parent_window = GTK_WIDGET(parent_window)->parent;
	}
	font_window = waaf_create_font_window(parent_window, font_name);
	gtk_widget_show(font_window);
	gtk_main();

	g_free(font_name);
	font_name = g_strconcat(Waaf_fname, NULL);
	g_free(Waaf_fname);
	Waaf_fname = NULL;

	return font_name;
}

/*===============
 *   ̾ : waaf_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			waaf_cb_destroy(void)
{
	gtk_main_quit();
}

/*===============
 *   ̾ : waaf_cb_ok_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			waaf_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) եꥦɥ
guint				call_data			// (I) ̤
)
{
	GtkFontSelectionDialog	*font_window;// ե򥦥ɥ
	GtkFontSelection	*fontsel;		//

	font_window = (GtkFontSelectionDialog *)main_window;
	fontsel = GTK_FONT_SELECTION(font_window->fontsel);
	g_free(Waaf_fname);
	Waaf_fname = gtk_font_selection_get_font_name(fontsel);
	Waaf_fname = gtk_font_selection_dialog_get_font_name(font_window);

	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : waaf_create_font_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*waaf_create_font_window(
GtkWidget			*parent,			// (I) ƥɥ
gchar				*font_name			// (I) ե̾
)
{
	GtkWidget		*font_window;		// ɥ
	GtkFontSelectionDialog	*fontdialog;//
	GtkWidget		*ok_btn;			// ܥ
	GtkWidget		*cancel_btn;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_FONT), NULL);
	font_window = gtk_font_selection_dialog_new(title);
	gtk_window_set_position(GTK_WINDOW(font_window),
							GTK_WIN_POS_MOUSE);
	gtk_container_set_border_width(GTK_CONTAINER(font_window), 10);
	gtk_signal_connect(GTK_OBJECT(font_window), "destroy",
						GTK_SIGNAL_FUNC(waaf_cb_destroy),
						GTK_OBJECT(font_window));
	g_free(title);

	// ե
	fontdialog = (GtkFontSelectionDialog *)font_window;
	gtk_font_selection_dialog_set_font_name(fontdialog, font_name);

	// ܥ
	ok_btn = GTK_FONT_SELECTION_DIALOG(font_window)->ok_button;
	gtk_widget_show(ok_btn);
	GTK_WIDGET_SET_FLAGS(ok_btn, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(ok_btn), "clicked",
						GTK_SIGNAL_FUNC(waaf_cb_ok_clicked),
						GTK_OBJECT(font_window));

	cancel_btn = GTK_FONT_SELECTION_DIALOG(font_window)->cancel_button;
	gtk_widget_show(cancel_btn);
	GTK_WIDGET_SET_FLAGS(cancel_btn, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(cancel_btn), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(font_window));

	gtk_widget_grab_default(ok_btn);

	gtk_window_set_modal(GTK_WINDOW(font_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(font_window),
								GTK_WINDOW(parent));

	return font_window;
}
