/*
 * ȣХϥե
 *	ʰףƣԣХ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_ftp.c,v 1.1 2000/08/25 11:52:42 tonton Exp $
 */

#include <gtk/gtk.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static GtkWidget	*Waaf_server;		// С̾
static GtkWidget	*Waaf_user;			// 桼̾
static GtkWidget	*Waaf_pass;			// ѥ
static GtkWidget	*Waaf_save_pass;	// ѥɤ¸
static GtkWidget	*Waaf_svr_dir;		// Сǥ쥯ȥ
static GtkWidget	*Waaf_loc_dir;		// ǥ쥯ȥ
static GtkWidget	*Waaf_logfile;		// ե̾

static void			waaf_cb_connect_clicked(GtkWidget *, gpointer);
static GtkWidget	*waaf_create_ftp_window(GtkWidget *);
static void			waaf_change_text_cursor(gint);

/*===============
 *   ̾ : waa_cb_medit_ftp()
 *     ǽ : ƣԣХɥκ
 *    : ʤ
 */
void				waa_cb_medit_ftp(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				call_data			// (I) ̤
)
{
	GtkWidget		*ftp_window;		// ƣԣХɥ

	ftp_window = waaf_create_ftp_window(main_window);
	gtk_widget_show_all(ftp_window);
}

/*===============
 *   ̾ : waaf_cb_connect_clicked()
 *     ǽ : ³ܥ󲡲Хå
 *    : ʤ
 */
static void			waaf_cb_connect_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			ftp_window			// (I) ƣԣХɥ
)
{
	GdkCursor		*wait_cur;			// Ԥ
	gchar			*svr_name;			// С̾
	gchar			*user_name;			// 桼̾
	gchar			*pass_word;			// ѥ
	gint			save_pass;			// ѥɤ¸
	gchar			*svr_dir;			// Сǥ쥯ȥ
	gchar			*loc_dir;			// ǥ쥯ȥ
	gchar			*log_file;			// ե̾
	gboolean		ret_code = FALSE;	// 
	gchar			*err_msg;			// 顼å

	wait_cur = gdk_cursor_new(GDK_WATCH);
	gdk_window_set_cursor(GTK_WIDGET(ftp_window)->window, wait_cur);
	waaf_change_text_cursor(GDK_WATCH);
	gtk_main_iteration_do(FALSE);

	svr_name =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_server)), NULL);
	user_name =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_user)), NULL);
	pass_word =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_pass)), NULL);
	svr_dir =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_svr_dir)), NULL);
	loc_dir =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_loc_dir)), NULL);
	log_file =
		g_strconcat(gtk_entry_get_text(GTK_ENTRY(Waaf_logfile)), NULL);

	if ((svr_name[0] == '\0') || (user_name[0] == '\0') ||
		(pass_word[0] == '\0') || (log_file[0] == '\0')) {
		err_msg = g_strconcat(_(WAA_STR_ERRF_NOINP), NULL);
		wmc_create_emsg_dialog(ftp_window, _(WAA_STR_ERROR), err_msg);
		g_free(err_msg);
	}
	else {
		ret_code = waa_ftp_get(svr_name,
			user_name, pass_word, svr_dir, loc_dir, log_file);
		if (ret_code == TRUE) {
			waa_put_param(WAA_PRM_KEY_FTPSERVER, svr_name);
			waa_put_param(WAA_PRM_KEY_FTPUSER, user_name);
			waa_put_param(WAA_PRM_KEY_FTPPASS, pass_word);
			waa_put_param(WAA_PRM_KEY_FTPSVRDIR, svr_dir);
			waa_put_param(WAA_PRM_KEY_FTPLOCDIR, loc_dir);
			waa_put_param(WAA_PRM_KEY_FTPLOGFILE, log_file);
			save_pass = GTK_TOGGLE_BUTTON(Waaf_save_pass)->active;
			waa_put_param(WAA_PRM_KEY_FTPSAVEPASS, (void *)save_pass);

			gtk_widget_destroy(ftp_window);
		}
		else {
			err_msg = g_strconcat(_(WAA_STR_ERRF_GET), NULL);
			wmc_create_emsg_dialog(ftp_window,
					_(WAA_STR_ERROR), err_msg);
			g_free(err_msg);
		}
	}
	g_free(svr_name);
	g_free(user_name);
	g_free(pass_word);
	g_free(svr_dir);
	g_free(loc_dir);
	g_free(log_file);
	gdk_cursor_destroy(wait_cur);

	if (ret_code == FALSE) {
		wait_cur = gdk_cursor_new(GDK_LEFT_PTR);
		gdk_window_set_cursor(GTK_WIDGET(ftp_window)->window, wait_cur);
		gdk_cursor_destroy(wait_cur);
		waaf_change_text_cursor(GDK_XTERM);
	}
}

/*===============
 *   ̾ : waaf_create_ftp_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*waaf_create_ftp_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*ftp_window;		// ɥ
	GtkWidget		*ftp_vbox;			//
	GtkWidget		*ftp_hbox;			//
	GtkWidget		*item_vbox;			//
	GtkWidget		*item_hbox;			//
	GtkWidget		*item_label;		// Ƽ٥
	gchar			*item_str;			// 
	GtkWidget		*connect_btn;		// ³ܥ
	GtkWidget		*cancel_btn;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_FTP), NULL);
	ftp_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(ftp_window), title);
	gtk_window_set_position(GTK_WINDOW(ftp_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(ftp_window), TRUE, TRUE, FALSE);
	gtk_widget_realize(ftp_window);
	g_free(title);

	//
	ftp_vbox = gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(ftp_vbox), 15);
	gtk_container_add(GTK_CONTAINER(ftp_window), ftp_vbox);
	ftp_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_vbox), ftp_hbox, TRUE, TRUE, 0);

	// С̾
	item_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_hbox), item_vbox, TRUE, TRUE, 0);
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_hbox, TRUE, TRUE, 0);
	item_label = gtk_label_new(_(WAA_STR_FTP_SERVER));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 5);
	Waaf_server = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPSERVER, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_server), item_str);
	gtk_box_pack_start(GTK_BOX(item_hbox), Waaf_server, TRUE, TRUE, 5);

	// 桼̾
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_hbox, TRUE, TRUE, 0);
	item_label = gtk_label_new(_(WAA_STR_FTP_USER));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 5);
	Waaf_user = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPUSER, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_user), item_str);
	gtk_box_pack_start(GTK_BOX(item_hbox), Waaf_user, TRUE, TRUE, 5);

	// ѥ
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_hbox, TRUE, TRUE, 0);
	item_label = gtk_label_new(_(WAA_STR_FTP_PASS));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 5);
	Waaf_pass = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPPASS, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_pass), item_str);
	gtk_entry_set_visibility(GTK_ENTRY(Waaf_pass), FALSE);
	gtk_box_pack_start(GTK_BOX(item_hbox), Waaf_pass, TRUE, TRUE, 5);

	// ѥɤ¸
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_hbox, TRUE, TRUE, 0);
	Waaf_save_pass =
		gtk_check_button_new_with_label(_(WAA_STR_FTP_SAVEPASS));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waaf_save_pass),
				(gboolean)waa_get_param(WAA_PRM_KEY_FTPSAVEPASS, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waaf_save_pass, FALSE, FALSE, 10);

	// ³ܥ
	item_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_hbox), item_vbox, FALSE, TRUE, 5);
	connect_btn = gtk_button_new_with_label(_(WAA_STR_BTN_CONNECT));
	gtk_box_pack_start(GTK_BOX(item_vbox), connect_btn, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(connect_btn), "clicked",
						GTK_SIGNAL_FUNC(waaf_cb_connect_clicked),
						GTK_OBJECT(ftp_window));
	GTK_WIDGET_SET_FLAGS(connect_btn, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(connect_btn);

	// ߥܥ
	cancel_btn = gtk_button_new_with_label(_(WAA_STR_BTN_CANCEL));
	gtk_box_pack_start(GTK_BOX(item_vbox), cancel_btn, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cancel_btn), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(ftp_window));
	GTK_WIDGET_SET_FLAGS(cancel_btn, GTK_CAN_DEFAULT);

	// Сǥ쥯ȥ
	item_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_vbox), item_vbox, FALSE, TRUE, 5);
	item_label = gtk_label_new(_(WAA_STR_FTP_SVRDIR));
	gtk_misc_set_alignment(GTK_MISC(item_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_label, FALSE, FALSE, 0);
	Waaf_svr_dir = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPSVRDIR, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_svr_dir), item_str);
	gtk_box_pack_start(GTK_BOX(item_vbox),
			Waaf_svr_dir, FALSE, FALSE, 0);

	// ǥ쥯ȥ
	item_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_vbox), item_vbox, FALSE, TRUE, 5);
	item_label = gtk_label_new(_(WAA_STR_FTP_LOCDIR));
	gtk_misc_set_alignment(GTK_MISC(item_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_label, FALSE, FALSE, 0);
	Waaf_loc_dir = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPLOCDIR, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_loc_dir), item_str);
	gtk_box_pack_start(GTK_BOX(item_vbox),
			Waaf_loc_dir, FALSE, FALSE, 0);

	// ե̾
	item_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ftp_vbox), item_vbox, FALSE, TRUE, 5);
	item_label = gtk_label_new(_(WAA_STR_FTP_LOGFILE));
	gtk_misc_set_alignment(GTK_MISC(item_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(item_vbox), item_label, FALSE, FALSE, 0);
	Waaf_logfile = gtk_entry_new();
	item_str = waa_get_param(WAA_PRM_KEY_FTPLOGFILE, 0);
	gtk_entry_set_text(GTK_ENTRY(Waaf_logfile), item_str);
	gtk_box_pack_start(GTK_BOX(item_vbox),
			Waaf_logfile, FALSE, FALSE, 0);

	gtk_window_set_modal(GTK_WINDOW(ftp_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(ftp_window),
								GTK_WINDOW(parent));

	return ftp_window;
}

/*===============
 *   ̾ : waaf_change_text_cursor()
 *     ǽ : ƥȥꥢѹ
 *    : ʤ
 */
static void			waaf_change_text_cursor(
gint				cur_type			// (I) 
)
{
	GdkCursor		*chg_cur;			// Ԥ

	chg_cur = gdk_cursor_new(cur_type);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_server)->text_area, chg_cur);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_user)->text_area, chg_cur);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_pass)->text_area, chg_cur);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_svr_dir)->text_area, chg_cur);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_loc_dir)->text_area, chg_cur);
	gdk_window_set_cursor(GTK_ENTRY(Waaf_logfile)->text_area, chg_cur);
	gdk_cursor_destroy(chg_cur);
}
