/*
 * ȣХϥե
 *	ƣԣм
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_ftpd.c,v 1.2 2000/09/04 01:18:39 tonton Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <glib.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

#define		WAAF_PORT_NO			21		// ݡֹ
#define		WAAF_SVR_TIME_OUT		10		// Ԥ()
#define		WAAF_WAIT_TIME			200		// ꡼׻(ߥ)

static gint			Waaf_ctrl;				// ³ѥåȣɣ

static gboolean		waaf_login(gchar *, gchar *, gchar *, gchar *);
static gboolean		waaf_get_file(gchar *, gchar *);
static gboolean		waaf_connect(gchar *);
static gboolean		waaf_send_command(gchar *);
static gboolean		waaf_data_sock(gint *);
static gboolean		waaf_response(void);
static gboolean		waaf_get_svrline(gchar *);
static void			waaf_close(void);

/*===============
 *   ̾ : waa_ftp_get()
 *     ǽ : ե
 *    : TRUE= , FALSE= 
 */
gboolean			waa_ftp_get(
gchar				*svr_name,			// (I) С̾
gchar				*usr_name,			// (I) 桼̾
gchar				*pass_word,			// (I) ѥ
gchar				*svr_dir,			// (I) Сǥ쥯ȥ
gchar				*local_dir,			// (I) ǥ쥯ȥ
gchar				*file_name			// (I) ե̾
)
{
	gint			ret_code;			// 

	waa_create_info_window();
	ret_code = waaf_login(svr_name, usr_name, pass_word, svr_dir);
	if (ret_code == TRUE) {
		ret_code = waaf_get_file(local_dir, file_name);
	}
	waaf_close();
	waa_delete_text_info();

	return ret_code;
}

/*===============
 *   ̾ : waaf_login()
 *     ǽ : С˥
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_login(
gchar				*svr_name,			// (I) С̾
gchar				*usr_name,			// (I) 桼̾
gchar				*pass_word,			// (I) ѥ
gchar				*svr_dir			// (I) Сǥ쥯ȥ
)
{
	gboolean		ret_code;			// 
	gchar			*cmd_buff;			// ޥɥХåե

	ret_code = waaf_connect(svr_name);
	if (ret_code == TRUE) {
		cmd_buff = g_strconcat("USER ", usr_name, NULL);
		ret_code = waaf_send_command(cmd_buff);
		g_free(cmd_buff);
	}
	if (ret_code == TRUE) {
		cmd_buff = g_strconcat("PASS ", pass_word, NULL);
		ret_code = waaf_send_command(cmd_buff);
		g_free(cmd_buff);
	}
	if (ret_code == TRUE) {
		if (svr_dir[0] != '\0') {
			cmd_buff = g_strconcat("CWD ", svr_dir, NULL);
			ret_code = waaf_send_command(cmd_buff);
			g_free(cmd_buff);
		}
	}
	if (ret_code == TRUE) {
		ret_code = waaf_send_command("TYPE I");
	}

	return ret_code;
}

/*===============
 *   ̾ : waaf_get_file()
 *     ǽ : ե
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_get_file(
gchar				*local_dir,			// (I) ǥ쥯ȥ
gchar				*file_name			// (I) ե̾
)
{
	gint			ret_code;			// 
	gint			recv_ret;			// 
	gint			get_sock;			// եå
	gint			get_desc;			// եå
	gchar			*read_buff;			// ɤ߹ߥХåե
	gchar			*cmd_buff;			// ޥɥХåե
	gint			retry_num;			// ɤ߹߲
	gchar			*local_file;		// ե̾
	FILE			*wfp;				// եݥ

	read_buff = g_malloc0(100000);

	// å
	ret_code = waaf_data_sock(&get_sock);
	if (ret_code == TRUE) {
		cmd_buff = g_strconcat("RETR ", file_name, NULL);
		ret_code = waaf_send_command(cmd_buff);
		g_free(cmd_buff);
	}

	// ³
	if (ret_code == TRUE) {
		get_desc = accept(get_sock, 0, 0);
		if (get_desc < 0) {
			ret_code = FALSE;
		}
		else {
			recv_ret = recv(get_desc, read_buff, 1, MSG_PEEK);
			retry_num = WAAF_SVR_TIME_OUT * 5;
			while ((recv_ret < 0) && (retry_num > 0)) {
				wmc_sleep(WAAF_WAIT_TIME);
				recv_ret = recv(get_desc, read_buff, 1, MSG_PEEK);
				retry_num--;
			}
			if ((recv_ret < 0) && (retry_num <= 0)) {
				ret_code = FALSE;
			}
		}
	}

	// 
	if (ret_code == TRUE) {
		cmd_buff = g_strconcat("mkdir -p ", local_dir, NULL);
		system(cmd_buff);
		g_free(cmd_buff);

		if (local_dir[0] == '\0') {
			local_file = g_strconcat("./", file_name, NULL);
		}
		else {
			local_file = g_strconcat(local_dir, "/", file_name, NULL);
		}
		wfp = fopen(local_file, "wb");
		if (wfp) {
			recv_ret = read(get_desc, read_buff, sizeof(read_buff));
			while (recv_ret > 0) {
				fwrite(read_buff, 1, recv_ret, wfp);
				recv_ret = read(get_desc, read_buff, sizeof(read_buff));
			}
			fclose(wfp);
		}
		else {
			perror(local_file);
			ret_code = FALSE;
		}
		g_free(local_file);
	}

	g_free(read_buff);
	close(get_sock);
	return ret_code;
}

/*===============
 *   ̾ : waaf_connect()
 *     ǽ : Сؤ³
 *    : TRUE= ³, FALSE= 
 */
static gboolean		waaf_connect(
gchar				*host_name			// (I) ۥ̾
)
{
	gint			ret_code = FALSE;	// 
	gint			ret_conn;			// 
	gint			opt = 1;			// åȥץ
	gint			ip_address;			// ɣХɥ쥹
	struct hostent	*host_info;			// ۥ̾ɣѴ
	struct sockaddr_in	sock_in;		// åȥɥ쥹

	Waaf_ctrl = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (Waaf_ctrl) {
		setsockopt(Waaf_ctrl, SOL_SOCKET, SO_REUSEADDR,
								(char *)&opt, sizeof(opt));

		memset(&sock_in, 0, sizeof(sock_in));
		ip_address = inet_addr(host_name);
		if (ip_address == -1) {
			host_info = gethostbyname(host_name);
			if (host_info) {
				memcpy(&sock_in.sin_addr,
					host_info->h_addr, host_info->h_length);
			}
		}
		else {
			sock_in.sin_addr.s_addr = ip_address;
		}

		if (sock_in.sin_addr.s_addr != 0) {
			sock_in.sin_family = AF_INET;
			sock_in.sin_port = htons(WAAF_PORT_NO);

			ret_conn = connect(Waaf_ctrl,
				(struct sockaddr *)&sock_in, sizeof(sock_in));
			if (ret_conn == 0) {
				ret_code = TRUE;
			}
		}
	}

	return (ret_code == TRUE) ? waaf_response() : FALSE;
}

/*===============
 *   ̾ : waaf_send_command()
 *     ǽ : С˥ޥɤ
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_send_command(
gchar				*command_str		// (I) ޥ
)
{
	gboolean		ret_code = FALSE;	// 
	gint			ret_send;			// 
	gchar			*send_buff;			// ޥ

	if (Waaf_ctrl) {
		send_buff = g_strconcat(command_str, "\r\n", NULL);
		ret_send = send(Waaf_ctrl, send_buff, strlen(send_buff), 0);
		if (ret_send > 0) {
			ret_code = TRUE;
		}
		g_free(send_buff);
	}

	return (ret_code == TRUE) ? waaf_response() : FALSE;
}

/*===============
 *   ̾ : waaf_data_sock()
 *     ǽ : ǡåȤκ
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_data_sock(
gint				*data_sock			// (O) å
)
{
	gboolean		ret_code = FALSE;	// 
	gchar			port_cmd[100];		// PORT ޥ
	gint			data_size;			// åȥǡ
	struct sockaddr_in	data_src;		// åȥǡ
	struct sockaddr_in	data_dst;		// åȥǡ

	*data_sock = 0;
	if (Waaf_ctrl) {
		*data_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		memset(&data_src, 0, sizeof(data_src));
		data_src.sin_family = AF_INET;
		data_src.sin_addr.s_addr = INADDR_ANY;
		data_src.sin_port = htons(0);
		bind(*data_sock,
			(struct sockaddr *)&data_src, sizeof(data_src));

		data_size = sizeof(data_src);
		getsockname(*data_sock,
			(struct sockaddr *)&data_src, &data_size);

		listen(*data_sock, 1);

		data_size = sizeof(data_src);
		getsockname(Waaf_ctrl,
			(struct sockaddr *)&data_dst, &data_size);

		sprintf(port_cmd, "PORT %d,%d,%d,%d,%d,%d",
			(int)((char *)&data_dst.sin_addr)[0] & 0xff,
			(int)((char *)&data_dst.sin_addr)[1] & 0xff,
			(int)((char *)&data_dst.sin_addr)[2] & 0xff,
			(int)((char *)&data_dst.sin_addr)[3] & 0xff,
			(int)((char *)&data_src.sin_port)[0] & 0xff,
			(int)((char *)&data_src.sin_port)[1] & 0xff);

		ret_code = waaf_send_command(port_cmd);
	}

	return ret_code;
}

/*===============
 *   ̾ : waaf_response()
 *     ǽ : СΥ쥹ݥ󥹼
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_response(void)
{
	gboolean		ret_code = FALSE;	// 
	gboolean		loop_flag;			// 롼ץե饰
	gint			ftp_code;			// ƣԣХ
	gchar			res_str[1000];		// 쥹ݥʸ

	if (Waaf_ctrl) {
		loop_flag = TRUE;
		ftp_code = 999;
		while (loop_flag) {
			memset(res_str, 0, sizeof(res_str));
			ret_code = waaf_get_svrline(res_str);
			if (ret_code == TRUE) {
// ȤꤢСαɽƤ
waa_add_text_info(res_str);
				if (res_str[3] != '-') {
					ftp_code = atoi(res_str);
					loop_flag = FALSE;
				}
			}
			else {
				loop_flag = FALSE;
			}
		}
		if (ftp_code >= 400) {
			ret_code = FALSE;
		}
	}

	return ret_code;
}

/*===============
 *   ̾ : waaf_get_svrline()
 *     ǽ : Сɤ߹
 *    : TRUE= , FALSE= 
 */
static gboolean		waaf_get_svrline(
gchar				*read_buff			// (O) ɤ߹ߥǡ
)
{
	gboolean		ret_code = FALSE;	// 
	gint			ret_svr;			// 
	gboolean		loop_flag;			// 롼ץե饰
	gchar			rcv_char;			// ʸ
	gchar			*read_ptr;			// ɤ߹߰
	gint			retry_num;			// ɤ߹߲

	read_ptr = read_buff;
	if (Waaf_ctrl) {
		loop_flag = TRUE;

		while (loop_flag) {
			rcv_char = '\0';
			ret_svr = recv(Waaf_ctrl, &rcv_char, 1, MSG_DONTWAIT);
			if (ret_svr < 0) {
				retry_num = WAAF_SVR_TIME_OUT * 5;
				while (retry_num > 0) {
					wmc_sleep(WAAF_WAIT_TIME);
					ret_svr = recv(Waaf_ctrl, &rcv_char,
										1, MSG_DONTWAIT);
					if (ret_svr >= 0) {
						retry_num = 0;
					}
					else {
						retry_num--;
						loop_flag = (retry_num <= 0) ? FALSE : TRUE;
					}
				}
			}
			if (loop_flag == TRUE) {
				if (rcv_char == '\n') {
					ret_code = TRUE;
					loop_flag = FALSE;
				}
				else if (rcv_char != '\r') {
					*(read_ptr++) = rcv_char;
				}
			}
		}
	}
	read_ptr = '\0';

	return ret_code;
}

/*===============
 *   ̾ : waaf_close()
 *     ǽ : åȤΥ
 *    : ʤ
 */
static void			waaf_close(void)
{
	if (Waaf_ctrl) {
		close(Waaf_ctrl);
		Waaf_ctrl = 0;
	}
}
