/*
 * ȣХϥե
 *	ѥ᡼ͤμ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_param.c,v 1.3 2000/09/04 01:18:39 tonton Exp $
 */

#include <sys/param.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

#define		WAAP_INIFILE	".acalzrc"

/* ǥե */
#define		WAAP_PRM_DEF_BASEWIDTH		WAA_DEF_BASE_WIDTH
#define		WAAP_PRM_DEF_BASEHEIGHT		WAA_DEF_BASE_HEIGHT
#define		WAAP_PRM_DEF_MONTHWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_MONTHHEIGHT	WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_WEEKWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_WEEKHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_DWEEKWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_DWEEKHEIGHT	WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_DATEWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_DATEHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_TIMEWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_TIMEHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_OSWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_OSHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_BRWSWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_BRWSHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_HOSTWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_HOSTHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_REFWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_REFHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_PAGEWIDTH		WAA_DEF_WINDOW_WIDTH
#define		WAAP_PRM_DEF_PAGEHEIGHT		WAA_DEF_WINDOW_HEIGHT
#define		WAAP_PRM_DEF_CHECKLINE		500

#define		WAAP_PRM_DEF_VISWINDOW		0
#define		WAAP_PRM_DEF_LOGFILE		"access.log"
#define		WAAP_PRM_DEF_PAGE			"index"
#define		WAAP_PRM_DEF_MAXDISP		25

#define		WAAP_PRM_DEF_GRAPHFORE		{0, 0x0000, 0x0000, 0x0000}
#define		WAAP_PRM_DEF_GRAPHBACK		{0, 0xffff, 0xffff, 0xffff}
#define		WAAP_PRM_DEF_GRAPHMONTH		{0, 0xffff, 0x0000, 0x0000}
#define		WAAP_PRM_DEF_GRAPHWEEK		{0, 0xffff, 0x8000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHDWEEK		{0, 0xffff, 0x8000, 0x4000}
#define		WAAP_PRM_DEF_GRAPHDATE		{0, 0xeb00, 0xe100, 0x7300}
#define		WAAP_PRM_DEF_GRAPHTIME		{0, 0x0000, 0xffff, 0x4000}
#define		WAAP_PRM_DEF_GRAPHOS		{0, 0x0000, 0xffff, 0xffff}
#define		WAAP_PRM_DEF_GRAPHBRWS		{0, 0x0000, 0x8000, 0xffff}
#define		WAAP_PRM_DEF_GRAPHHOST		{0, 0x0000, 0x2000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHREF		{0, 0x8000, 0x0000, 0x8000}
#define		WAAP_PRM_DEF_GRAPHPAGE		{0, 0xffff, 0x8000, 0xffff}

#define		WAAP_PRM_DEF_FONTNAME		"6x12"
#define		WAAP_PRM_DEF_KANJIFONT		"k12"

/* ѥ᡼ */
enum {
	WAAP_TYPE_BOOL = 1,
	WAAP_TYPE_INT,
	WAAP_TYPE_CHAR,
	WAAP_TYPE_TIME,
	WAAP_TYPE_COLOR,
	WAAP_TYPE_LOG,
	WAAP_TYPE_PASS
};

typedef union {
	gboolean		b_value;			// ֡뷿
	gint			i_value;			// 
	gchar			*s_value;			// ʸ
	time_t			t_value;			// ַ
	GdkColor		c_value;			// 
	gchar			**l_value;			// 
} WAAP_VALUE;

/*
 *	ѥ᡼ϰϥå
 *	ϰϥåϡΤߤǤ
 *	ʺǾͤȺͤƱϥåޤ
 */
typedef struct {
	gint			min_value;			// Ǿ
	gint			max_value;			// 
} WAAP_RANGE;

typedef struct {
	gint			prm_type;			// ѥ᡼
	gchar			*prm_name;			// ѥ᡼̾
	WAAP_VALUE		prm_value;			// ѥ᡼
	WAAP_VALUE		def_value;			// ǥե
	WAAP_RANGE		check_range;		// ϰϥå
} WAAP_PVALUE;
static WAAP_PVALUE	Waap_pvalue[] = {	// ѥ᡼
	// ɥ⤵
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BASEWIDTH,
		{ WAAP_PRM_DEF_BASEWIDTH }, { WAAP_PRM_DEF_BASEWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BASEHEIGHT,
		{ WAAP_PRM_DEF_BASEHEIGHT }, { WAAP_PRM_DEF_BASEHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_MONTHWIDTH,
		{ WAAP_PRM_DEF_MONTHWIDTH }, { WAAP_PRM_DEF_MONTHWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_MONTHHEIGHT,
		{ WAAP_PRM_DEF_MONTHHEIGHT }, { WAAP_PRM_DEF_MONTHHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_WEEKWIDTH,
		{ WAAP_PRM_DEF_WEEKWIDTH }, { WAAP_PRM_DEF_WEEKWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_WEEKHEIGHT,
		{ WAAP_PRM_DEF_WEEKHEIGHT }, { WAAP_PRM_DEF_WEEKHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DWEEKWIDTH,
		{ WAAP_PRM_DEF_DWEEKWIDTH }, { WAAP_PRM_DEF_DWEEKWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DWEEKHEIGHT,
		{ WAAP_PRM_DEF_DWEEKHEIGHT }, { WAAP_PRM_DEF_DWEEKHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DATEWIDTH,
		{ WAAP_PRM_DEF_DATEWIDTH }, { WAAP_PRM_DEF_DATEWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_DATEHEIGHT,
		{ WAAP_PRM_DEF_DATEHEIGHT }, { WAAP_PRM_DEF_DATEHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_TIMEWIDTH,
		{ WAAP_PRM_DEF_TIMEWIDTH }, { WAAP_PRM_DEF_TIMEWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_TIMEHEIGHT,
		{ WAAP_PRM_DEF_TIMEHEIGHT }, { WAAP_PRM_DEF_TIMEHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_OSWIDTH,
		{ WAAP_PRM_DEF_OSWIDTH }, { WAAP_PRM_DEF_OSWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_OSHEIGHT,
		{ WAAP_PRM_DEF_OSHEIGHT }, { WAAP_PRM_DEF_OSHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BRWSWIDTH,
		{ WAAP_PRM_DEF_BRWSWIDTH }, { WAAP_PRM_DEF_BRWSWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_BRWSHEIGHT,
		{ WAAP_PRM_DEF_BRWSHEIGHT }, { WAAP_PRM_DEF_BRWSHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_HOSTWIDTH,
		{ WAAP_PRM_DEF_HOSTWIDTH }, { WAAP_PRM_DEF_HOSTWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_HOSTHEIGHT,
		{ WAAP_PRM_DEF_HOSTHEIGHT }, { WAAP_PRM_DEF_HOSTHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_REFWIDTH,
		{ WAAP_PRM_DEF_REFWIDTH }, { WAAP_PRM_DEF_REFWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_REFHEIGHT,
		{ WAAP_PRM_DEF_REFHEIGHT }, { WAAP_PRM_DEF_REFHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_PAGEWIDTH,
		{ WAAP_PRM_DEF_PAGEWIDTH }, { WAAP_PRM_DEF_PAGEWIDTH },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_PAGEHEIGHT,
		{ WAAP_PRM_DEF_PAGEHEIGHT }, { WAAP_PRM_DEF_PAGEHEIGHT },
		{ 0, 0 } },
	{ WAAP_TYPE_INT, WAA_PRM_KEY_CHECKLINE,
		{ WAAP_PRM_DEF_CHECKLINE }, { WAAP_PRM_DEF_CHECKLINE },
		{ 10, 10000 } },

	// Ͼ
	{ WAAP_TYPE_INT, WAA_PRM_KEY_VISWINDOW,
		{ WAAP_PRM_DEF_VISWINDOW }, { WAAP_PRM_DEF_VISWINDOW },
		{ 0, 1023 } },
	{ WAAP_TYPE_LOG, WAA_PRM_KEY_LOGFILE,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCDATE,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_TIME, WAA_PRM_KEY_STARTDATE,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_TIME, WAA_PRM_KEY_ENDDATE,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCPAGE,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_PAGE,
		{ 0 }, { GPOINTER_TO_UINT(WAAP_PRM_DEF_PAGE) }, { 0, 0 } },

	// ץ
	{ WAAP_TYPE_INT, WAA_PRM_KEY_MAXDISP,
		{ WAAP_PRM_DEF_MAXDISP }, { WAAP_PRM_DEF_MAXDISP },
		{ 1, 999 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREIP,
		{ FALSE }, { FALSE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SPCCLASS,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_CODECHANGE,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_SMALLIZE,
		{ FALSE }, { FALSE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREINDEX,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREQUESTION,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNORESHARP,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_IGNOREPORTNO,
		{ TRUE }, { TRUE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_AUTOFTP,
		{ FALSE }, { FALSE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_AUTOANALYZE,
		{ FALSE }, { FALSE }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_AUTOTILE,
		{ FALSE }, { FALSE }, { 0, 0 } },

	// ƣԣ
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FTPSERVER,
		{ 0 }, { GPOINTER_TO_UINT("") }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FTPUSER,
		{ 0 }, { GPOINTER_TO_UINT("") }, { 0, 0 } },
	{ WAAP_TYPE_PASS, WAA_PRM_KEY_FTPPASS,
		{ 0 }, { GPOINTER_TO_UINT("") }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FTPSVRDIR,
		{ 0 }, { GPOINTER_TO_UINT("") }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FTPLOCDIR,
		{ 0 }, { GPOINTER_TO_UINT("") }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FTPLOGFILE,
		{ 0 }, { GPOINTER_TO_UINT(WAAP_PRM_DEF_LOGFILE) }, { 0, 0 } },
	{ WAAP_TYPE_BOOL, WAA_PRM_KEY_FTPSAVEPASS,
		{ FALSE }, { FALSE }, { 0, 0 } },

	// ɽ
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHFORE,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHBACK,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHMONTH,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHWEEK,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHDWEEK,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHDATE,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHTIME,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHOS,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHBRWS,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHHOST,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHREF,
		{ 0 }, { 0 }, { 0, 0 } },
	{ WAAP_TYPE_COLOR, WAA_PRM_KEY_GRAPHPAGE,
		{ 0 }, { 0 }, { 0, 0 } },

	// ե
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_FONTNAME,
		{ 0 }, { GPOINTER_TO_UINT(WAAP_PRM_DEF_FONTNAME) }, { 0, 0 } },
	{ WAAP_TYPE_CHAR, WAA_PRM_KEY_KANJIFONT,
		{ 0 }, { GPOINTER_TO_UINT(WAAP_PRM_DEF_KANJIFONT) }, { 0, 0 } },

	{ 0, NULL, { 0 }, { 0 }, { 0, 0 } }
};

static void			waa_put_def_color(gchar *, GdkColor *);
static void			waap_set_default_value(void);
static char			*waap_encrypt_password(gchar *);
static char			*waap_decrypt_password(gchar *);

/*===============
 *   ̾ : waa_get_param()
 *     ǽ : ѥ᡼ͤμ
 *    : ѥ᡼
 */
void				*waa_get_param(
gchar				*param_key,			// (I) ѥ᡼ɣ
gint				option_id			// (I) ղþ
)
{
	void			*param_value = NULL;// ѥ᡼
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	value_ptr = Waap_pvalue;
	while ((value_ptr->prm_type != 0) && (param_value == NULL)) {
		if (!strcmp(value_ptr->prm_name, param_key)) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				param_value = (void *)value_ptr->prm_value.b_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				param_value = (void *)value_ptr->prm_value.i_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				param_value = (void *)value_ptr->prm_value.s_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				param_value = (void *)value_ptr->prm_value.t_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				param_value = (void *)&value_ptr->prm_value.c_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				param_value =
					(void *)value_ptr->prm_value.l_value[option_id];
			}
			else if (value_ptr->prm_type == WAAP_TYPE_PASS) {
				param_value = (void *)value_ptr->prm_value.s_value;
			}
		}
		value_ptr++;
	}

	return param_value;
}

/*===============
 *   ̾ : waa_put_param()
 *     ǽ : ѥ᡼ͤΥå
 *    : ʤ
 */
void				waa_put_param(
gchar				*param_key,			// (I) ѥ᡼ɣ
void				*param_value		// (I) ѥ᡼
)
{
	gint			find_flag = FALSE;	// ե饰
	gint			loop_cnt;			// 롼ץ
	gint			tmp_num;			// ¸ե
	char			**new_log;			// ե̾
	char			**work_log;			// ѥե̾
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	value_ptr = Waap_pvalue;
	while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
		if (!strcmp(value_ptr->prm_name, param_key)) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				value_ptr->prm_value.b_value = (gboolean)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				value_ptr->prm_value.i_value = (gint)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				value_ptr->prm_value.s_value =
					g_realloc(value_ptr->prm_value.s_value,
					strlen(param_value) + 1);
				strcpy(value_ptr->prm_value.s_value, param_value);
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				value_ptr->prm_value.t_value = (time_t)param_value;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				memcpy(&value_ptr->prm_value.c_value,
					param_value, sizeof(GdkColor));
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				work_log = value_ptr->prm_value.l_value;
				new_log = (char **)g_malloc0(WAA_MAX_LOGFILE *
												sizeof(char *));
				tmp_num = 5;
				for (loop_cnt = (WAA_MAX_LOGFILE - 1);
					loop_cnt >= 0; loop_cnt--) {
					if (strcmp(param_value, work_log[loop_cnt])) {
						tmp_num--;
						new_log[tmp_num] =
							g_malloc0((strlen(work_log[loop_cnt]) + 1) *
							sizeof(char));
						strcpy(new_log[tmp_num], work_log[loop_cnt]);
					}
				}
				if (tmp_num == 0) {
					free(new_log[4]);
					memmove(&new_log[1], new_log,
						sizeof(char *) * (WAA_MAX_LOGFILE - 1));
				}
				new_log[0] = g_malloc0((strlen(param_value) + 1) *
												sizeof(char));
				strcpy(new_log[0], param_value);
				for (loop_cnt = 0;
					loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
					free(value_ptr->prm_value.l_value[loop_cnt]);
				}
				free(value_ptr->prm_value.l_value);
				value_ptr->prm_value.l_value = new_log;
			}
			else if (value_ptr->prm_type == WAAP_TYPE_PASS) {
				value_ptr->prm_value.s_value =
					g_realloc(value_ptr->prm_value.s_value,
					strlen(param_value) + 1);
				strcpy(value_ptr->prm_value.s_value, param_value);
			}
			find_flag = TRUE;
		}
		value_ptr++;
	}
}

/*===============
 *   ̾ : waa_read_inifile()
 *     ǽ : եɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gboolean			waa_read_inifile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			find_flag;			// ե饰
	gint			find_logfile;		// ե饰
	gint			loop_cnt;			// 롼ץ
	gchar			*fname;				// ե̾
	gchar			key_str[100];		// 
	gchar			key_value[100];		// 
	FILE			*infp;				// եݥ
	WAAP_PVALUE		*value_ptr;			// ѥ᡼
	WAAP_RANGE		*chk_rng;			// ϰϥå
	gint			iset_value;			// ͷΥѥ᡼

	find_logfile = FALSE;
	value_ptr = Waap_pvalue;
	find_flag = FALSE;
	while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
		if (!strcmp(value_ptr->prm_name, WAA_PRM_KEY_LOGFILE)) {
			value_ptr->prm_value.l_value =
				(char **)g_malloc0(WAA_MAX_LOGFILE * sizeof(char *));
			for (loop_cnt = 0; loop_cnt < WAA_MAX_LOGFILE; loop_cnt++) {
				value_ptr->prm_value.l_value[loop_cnt] =
									g_malloc0(sizeof(char));
			}
			find_flag = TRUE;
		}
		value_ptr++;
	}
	waap_set_default_value();

	if (getenv("HOME") != NULL) {
		fname = g_strconcat(getenv("HOME"), "/", WAAP_INIFILE, NULL);
	}
	else {
		fname = g_strconcat("./", WAAP_INIFILE, NULL);
	}
	infp = fopen(fname, "r");
	if (infp) {
		while (wmc_get_key_value(key_str, key_value, infp) == TRUE) {
			value_ptr = Waap_pvalue;
			find_flag = FALSE;
			while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
				if (!strcmp(value_ptr->prm_name, key_str)) {
					if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
						value_ptr->prm_value.b_value = atoi(key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_INT) {
						iset_value = atoi(key_value);
						chk_rng = &value_ptr->check_range;
						if (((chk_rng->min_value <= iset_value) &&
							(iset_value <= chk_rng->max_value)) &&
							(chk_rng->min_value != chk_rng->max_value)) {
							value_ptr->prm_value.i_value = iset_value;
						}
					}
					else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
						waa_put_param(value_ptr->prm_name, key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
						value_ptr->prm_value.t_value = atoi(key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
						wmc_get_color(&value_ptr->prm_value.c_value,
															key_value);
					}
					else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
						waa_put_param(value_ptr->prm_name, key_value);
						find_logfile = TRUE;
					}
					else if (value_ptr->prm_type == WAAP_TYPE_PASS) {
						waa_put_param(value_ptr->prm_name,
							waap_decrypt_password(key_value));
					}
					find_flag = TRUE;
				}
				value_ptr++;
			}
		}
		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}
	g_free(fname);

	if (find_logfile == FALSE) {
		waa_put_param(WAA_PRM_KEY_LOGFILE, WAAP_PRM_DEF_LOGFILE);
	}
	return ret_code;
}

/*===============
 *   ̾ : waa_write_inifile()
 *     ǽ : եν񤭹
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			waa_write_inifile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			loop_cnt;			// 롼ץ
	gint			prm_size;			// ѥ᡼
	gchar			*fname;				// ե̾
	FILE			*outfp;				// եݥ
	WAAP_PVALUE		*value_ptr;			// ѥ᡼
	gboolean		save_pass;			// ѥɤ¸

	if (getenv("HOME") != NULL) {
		fname = g_strconcat(getenv("HOME"), "/", WAAP_INIFILE, NULL);
	}
	else {
		fname = g_strconcat("./", WAAP_INIFILE, NULL);
	}
	outfp = fopen(fname, "w");
	if (outfp) {
		prm_size = sizeof(Waap_pvalue) / sizeof(Waap_pvalue[0]);
		// ɥ¸ʤ
		value_ptr = Waap_pvalue + 22;

		while (value_ptr->prm_type != 0) {
			if (value_ptr->prm_type == WAAP_TYPE_BOOL) {
				if (value_ptr->prm_value.b_value !=
					value_ptr->def_value.b_value) {
					fprintf(outfp, "%s = %d\n",
						value_ptr->prm_name,
						value_ptr->prm_value.b_value);
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_INT) {
				if (value_ptr->prm_value.i_value !=
					value_ptr->def_value.i_value) {
					fprintf(outfp, "%s = %d\n",
						value_ptr->prm_name,
						value_ptr->prm_value.i_value);
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_CHAR) {
				if (strcmp(value_ptr->prm_value.s_value,
					value_ptr->def_value.s_value)) {
					fprintf(outfp, "%s = %s\n",
						value_ptr->prm_name,
						value_ptr->prm_value.s_value);
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_TIME) {
				if (value_ptr->prm_value.t_value !=
					value_ptr->def_value.t_value) {
					fprintf(outfp, "%s = %ld\n",
						value_ptr->prm_name,
						value_ptr->prm_value.t_value);
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				if ((value_ptr->prm_value.c_value.red !=
					value_ptr->def_value.c_value.red) ||
					(value_ptr->prm_value.c_value.green !=
					value_ptr->def_value.c_value.green) ||
					(value_ptr->prm_value.c_value.blue !=
					value_ptr->def_value.c_value.blue)) {
					fprintf(outfp, "%s = %ld, %d, %d, %d\n",
						value_ptr->prm_name,
						value_ptr->prm_value.c_value.pixel,
						value_ptr->prm_value.c_value.red,
						value_ptr->prm_value.c_value.green,
						value_ptr->prm_value.c_value.blue);
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_LOG) {
				for (loop_cnt = (WAA_MAX_LOGFILE - 1);
					loop_cnt >= 0; loop_cnt--) {
					if (value_ptr->prm_value.l_value[loop_cnt][0] !=
																'\0') {
						fprintf(outfp, "%s = %s\n",
							value_ptr->prm_name,
							value_ptr->prm_value.l_value[loop_cnt]);
					}
				}
			}
			else if (value_ptr->prm_type == WAAP_TYPE_PASS) {
				save_pass =
					(gboolean)waa_get_param(WAA_PRM_KEY_FTPSAVEPASS, 0);
				if (save_pass == TRUE) {
					fprintf(outfp, "%s = %s\n",
						value_ptr->prm_name,
						waap_encrypt_password(
						value_ptr->prm_value.s_value));
				}
			}
			value_ptr++;
		}

		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}
	g_free(fname);

	return ret_code;
}

/*===============
 *   ̾ : waa_put_def_color()
 *     ǽ : ǥեȿ
 *    : ʤ
 */
static void			waa_put_def_color(
gchar				*param_key,			// (I) ѥ᡼ɣ
GdkColor			*param_value		// (I) ѥ᡼
)
{
	gint			find_flag = FALSE;	// ե饰
	WAAP_PVALUE		*value_ptr;			// ѥ᡼

	value_ptr = Waap_pvalue;
	while ((value_ptr->prm_type != 0) && (find_flag == FALSE)) {
		if (!strcmp(value_ptr->prm_name, param_key)) {
			if (value_ptr->prm_type == WAAP_TYPE_COLOR) {
				memcpy(&value_ptr->def_value.c_value,
					param_value, sizeof(GdkColor));
			}
			find_flag = TRUE;
		}
		value_ptr++;
	}
}

/*===============
 *   ̾ : waap_set_default_value()
 *     ǽ : ǥեȥѥ᡼
 *    : ʤ
 */
static void			waap_set_default_value(void)
{
	GdkColor		def_color[] = {		// ɽ
						WAAP_PRM_DEF_GRAPHFORE,
						WAAP_PRM_DEF_GRAPHBACK,
						WAAP_PRM_DEF_GRAPHMONTH,
						WAAP_PRM_DEF_GRAPHWEEK,
						WAAP_PRM_DEF_GRAPHDWEEK,
						WAAP_PRM_DEF_GRAPHDATE,
						WAAP_PRM_DEF_GRAPHTIME,
						WAAP_PRM_DEF_GRAPHOS,
						WAAP_PRM_DEF_GRAPHBRWS,
						WAAP_PRM_DEF_GRAPHHOST,
						WAAP_PRM_DEF_GRAPHREF,
						WAAP_PRM_DEF_GRAPHPAGE
					};
	time_t			ini_date;			// 
	struct tm		ini_sdate;			//

	ini_date = time(NULL);
	memcpy(&ini_sdate, localtime(&ini_date), sizeof(struct tm));
	ini_sdate.tm_hour = 0;
	ini_sdate.tm_min = 0;
	ini_sdate.tm_sec = 0;
	ini_date = mktime(&ini_sdate);
	waa_put_param(WAA_PRM_KEY_ENDDATE, (void *)ini_date);
	ini_sdate.tm_mday = 1;
	ini_date = mktime(&ini_sdate);
	waa_put_param(WAA_PRM_KEY_STARTDATE, (void *)ini_date);

	waa_put_param(WAA_PRM_KEY_PAGE, WAAP_PRM_DEF_PAGE);

	waa_put_param(WAA_PRM_KEY_FTPSERVER, "");
	waa_put_param(WAA_PRM_KEY_FTPUSER, "");
	waa_put_param(WAA_PRM_KEY_FTPPASS, "");
	waa_put_param(WAA_PRM_KEY_FTPSVRDIR, "");
	waa_put_param(WAA_PRM_KEY_FTPLOCDIR, "");
	waa_put_param(WAA_PRM_KEY_FTPLOGFILE, WAAP_PRM_DEF_LOGFILE);

	waa_put_param(WAA_PRM_KEY_GRAPHFORE, def_color);
	waa_put_def_color(WAA_PRM_KEY_GRAPHFORE, def_color);
	waa_put_param(WAA_PRM_KEY_GRAPHBACK, &def_color[1]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHBACK, &def_color[1]);
	waa_put_param(WAA_PRM_KEY_GRAPHMONTH, &def_color[2]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHMONTH, &def_color[2]);
	waa_put_param(WAA_PRM_KEY_GRAPHWEEK, &def_color[3]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHWEEK, &def_color[3]);
	waa_put_param(WAA_PRM_KEY_GRAPHDWEEK, &def_color[4]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHDWEEK, &def_color[4]);
	waa_put_param(WAA_PRM_KEY_GRAPHDATE, &def_color[5]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHDATE, &def_color[5]);
	waa_put_param(WAA_PRM_KEY_GRAPHTIME, &def_color[6]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHTIME, &def_color[6]);
	waa_put_param(WAA_PRM_KEY_GRAPHOS, &def_color[7]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHOS, &def_color[7]);
	waa_put_param(WAA_PRM_KEY_GRAPHBRWS, &def_color[8]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHBRWS, &def_color[8]);
	waa_put_param(WAA_PRM_KEY_GRAPHHOST, &def_color[9]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHHOST, &def_color[9]);
	waa_put_param(WAA_PRM_KEY_GRAPHREF, &def_color[10]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHREF, &def_color[10]);
	waa_put_param(WAA_PRM_KEY_GRAPHPAGE, &def_color[11]);
	waa_put_def_color(WAA_PRM_KEY_GRAPHPAGE, &def_color[11]);

	waa_put_param(WAA_PRM_KEY_FONTNAME, WAAP_PRM_DEF_FONTNAME);
	waa_put_param(WAA_PRM_KEY_KANJIFONT, WAAP_PRM_DEF_KANJIFONT);
}

/*===============
 *   ̾ : waap_encrypt_password()
 *     ǽ : ѥɤΰŹ沽
 *    : Ź沽ʸ
 */
static char			*waap_encrypt_password(
gchar				*password			// (I) Ź沽ѥ
)
{
	// եƤ뤷Ź沽ɬפϤʤʤ
	return password;
}

/*===============
 *   ̾ : waap_decrypt_password()
 *     ǽ : ѥɤ沽
 *    : 沽ʸ
 */
static char			*waap_decrypt_password(
gchar				*password			// (I) 沽ѥ
)
{
	return password;
}
