/*
 * ȣХϥե
 *	ᥤ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_main.c,v 1.3 2000/09/04 01:18:39 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdlib.h>
#include <libintl.h>

#include "acalz.h"
#include "aa_sdef.h"
#include "images/acalz.xpm"

static GtkFunction	waam_start_up(gpointer);

/*===============
 *   ̾ : main()
 *     ǽ : ȣХϥեȥᥤ
 *    : 0= ｪλ
 */
gint				main(
gint				argc,				// (I) ο
gchar				**argv				// (I) 
)
{
	void			(*disp_func[])() = {// ɽɥ
						waa_cb_view_month,
						waa_cb_view_week,
						waa_cb_view_dweek,
						waa_cb_view_date,
						waa_cb_view_time,
						waa_cb_view_os,
						waa_cb_view_brws,
						waa_cb_view_host,
						waa_cb_view_ref,
						waa_cb_view_page
					};
	GtkWidget		*main_window;		// ᥤ󥦥ɥ
	gchar			*rc_name;			// ե̾
	gint			loop_cnt;			// 롼ץ
	gint			vis_win;			// ɽΥɥ

	g_print("%s (Ver%s)\n", _(WAA_TITLE), WAA_VERSION);
	g_print("Copyright(C) 1999,2000 Whitire Company\n");

	textdomain("acalz");
	gtk_set_locale();
	gtk_init(&argc, &argv);
	waa_read_inifile();
	waa_read_analyze_info();

	rc_name = g_strconcat(getenv("HOME"), "/.gtkrc", NULL);
	gtk_rc_parse(rc_name);
	g_free(rc_name);

	main_window = waa_create_base_window();
	gtk_widget_show_all(main_window);
	waa_set_window_icon(main_window);

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	for (loop_cnt = 0; loop_cnt < WAA_MAX_WINNO; loop_cnt++) {
		if ((vis_win & (1 << loop_cnt)) != 0) {
			disp_func[loop_cnt]();
		}
	}

	gtk_timeout_add(500, (GtkFunction)waam_start_up, NULL);
	gtk_main();
	return 0;
}

/*===============
 *   ̾ : waa_set_window_icon()
 *     ǽ : Υå
 *    : ʤ
 */
void				waa_set_window_icon(
GtkWidget			*icon_win			// (I/O) åȤ륦ɥ
)
{
	GdkPixmap		*icon_img;			// 
	GdkBitmap		*icon_mask;			// Υޥ
	GtkStyle		*win_style;			// ɥ

	win_style = gtk_widget_get_style(icon_win);
	icon_img = gdk_pixmap_create_from_xpm_d(icon_win->window,
			&icon_mask, &win_style->bg[GTK_STATE_NORMAL], acalz_xpm);
	gdk_window_set_icon(icon_win->window, NULL, icon_img, icon_mask);
}

/*===============
 *   ̾ : waam_start_up()
 *     ǽ : ưνʥޡؿ
 *    : FALSE= Ƶʤ
 */
static GtkFunction	waam_start_up(
gpointer			event_data			// (I) ̤
)
{
	gboolean		start_up;			// ư
	gchar			*svr_name;			// С̾
	gchar			*user_name;			// 桼̾
	gchar			*pass_word;			// ѥ
	gchar			*svr_dir;			// Сǥ쥯ȥ
	gchar			*loc_dir;			// ǥ쥯ȥ
	gchar			*logfile;			//  ե̾
	gint			max_line;			// ιԿ

	// ƣԣ
	start_up = (gboolean)waa_get_param(WAA_PRM_KEY_AUTOFTP, 0);
	if (start_up == TRUE) {
		svr_name = waa_get_param(WAA_PRM_KEY_FTPSERVER, 0);
		user_name = waa_get_param(WAA_PRM_KEY_FTPUSER, 0);
		pass_word = waa_get_param(WAA_PRM_KEY_FTPPASS, 0);
		svr_dir = waa_get_param(WAA_PRM_KEY_FTPSVRDIR, 0);
		loc_dir = waa_get_param(WAA_PRM_KEY_FTPLOCDIR, 0);
		logfile = waa_get_param(WAA_PRM_KEY_FTPLOGFILE, 0);

		waa_ftp_get(svr_name, user_name, pass_word,
						svr_dir, loc_dir, logfile);
	}

	// 
	start_up = (gboolean)waa_get_param(WAA_PRM_KEY_AUTOANALYZE, 0);
	if (start_up == TRUE) {
		max_line = waa_get_analyze_line();
		if (max_line > 0) {
			waa_create_pbar_window(_(WAA_STR_ANALYZE),
									(gfloat)max_line);
		}
		waa_access_analyze(TRUE);
		waa_pbar_value_change((gfloat)max_line + 1);
	}

	// ɽ
	start_up = (gboolean)waa_get_param(WAA_PRM_KEY_AUTOTILE, 0);
	if (start_up == TRUE) {
		waa_line_up_window(WAA_WLINE_HTILE);
	}
	else {
		waa_line_up_window(WAA_WLINE_CASC);
	}

	return FALSE;
}
